#include <amxmod> 
#include <amxmisc>
#include <fun>
#include <Vexd_Utilities>

new beam, boom
new mines[33]
new gMsgDeathMsg

stock sqrt(num) 
  { 
   new div = num 
   new result = 1 
   while (div > result) 
   {  // end when div == result, or just below 
      div = (div + result) / 2 // take mean value as new divisor 
      result = num / div 
   } 
   return div 
} 

stock ExtraDamage(id, attacker, damage, weaponDescription[] ) 
  { 
     if ( is_user_alive(id) ) 
     { 
       new userHealth=get_user_health(id) 
       set_msg_block(gMsgDeathMsg, BLOCK_SET)
       set_user_health(id, userHealth - damage ) 
       set_msg_block(gMsgDeathMsg, BLOCK_NOT)
       if ( userHealth - damage <= 0 ) 
       { 
         if ( get_user_team(id) != get_user_team(attacker) ) 
         { 
           // The person dying shouldn't get negative credit for this kill (so add it back) 
           set_user_frags( id, get_user_frags(id) + 1 ) 
            
           // The killing should get credit for the frag 
           set_user_frags( attacker, get_user_frags(attacker)+ 1 ) 
           new money = get_user_money(attacker) 
           if (get_user_money(attacker) < 16000) 
              set_user_money(attacker,money + 300,1) 
         } 
         else 
         { 
           // The person dying shouldn't get negative credit for this kill (so add it back) 
           set_user_frags( id, get_user_frags(id)+ 1 )  
            
           // The killer killed a teammember or self 
           set_user_frags( attacker, get_user_frags(attacker) - 1) 
            
           new money = get_user_money(attacker) 
           if (get_user_money(attacker) != 0) 
              set_user_money(attacker,money - 150,1) 
         } 
                  
         message_begin(MSG_BROADCAST,gMsgDeathMsg,{0,0,0},0) 
         write_byte(attacker) 
         write_byte(id) 
         write_byte(0) 
         write_string(weaponDescription) 
         message_end() 
       } 
     } 
  } 

public blowUp( id, Float:vExplodeAt[3] ) 
{ 
   new distanceBetween 
   new damage, multiplier 

   new FFOn= get_cvar_num("mp_friendlyfire") 
   new origin[3] 
   origin[0]=floatround(vExplodeAt[0]) 
   origin[1]=floatround(vExplodeAt[1]) 
   origin[2]=floatround(vExplodeAt[2])
    
   for(new a = 1; a <= get_playersnum(); a++) 
   { 
     if( is_user_alive(a) && ( get_user_team(id) != get_user_team(a) || FFOn != 0 || a==id ) ) 
     { 
       new origin1[3] 
       get_user_origin(a,origin1) 
       distanceBetween = get_distance(origin, origin1) 
       if( distanceBetween < get_cvar_num("amx_mineradius") ) 
       { 
         multiplier=(get_cvar_num("amx_minemaxdmg")*get_cvar_num("amx_minemaxdmg"))/get_cvar_num("amx_mineradius") 
         damage=(get_cvar_num("amx_mineradius")-distanceBetween)*multiplier 
         damage=sqrt(damage) 
         ExtraDamage(a, id, damage, "TripMine")
       }
     }
   }   
} 

public Vexd_CreateMine(id) 
{
	if(!is_user_alive(id))
		return PLUGIN_HANDLED

	if(mines[id]>=get_cvar_num("amx_minesnum"))
	{
		client_print(id, print_chat, "You can only plant %d tripmine%s in a round.", get_cvar_num("amx_minesnum"), (get_cvar_num("amx_minesnum")>1)?"s":"")
		console_print(id, "You can only plant %d tripmine%s in a round.", get_cvar_num("amx_minesnum"), (get_cvar_num("amx_minesnum")>1)?"s":"")
		return PLUGIN_HANDLED
	}

	new Float:vOrigin[3]
	new Float:vAngles[3]
	Entvars_Get_Vector(id, EV_VEC_origin, vOrigin)
	Entvars_Get_Vector(id, EV_VEC_v_angle, vAngles)

  new NewEnt
  NewEnt = CreateEntity("info_target")

  if(NewEnt == 0) {
      return PLUGIN_HANDLED_MAIN
  }

	Entvars_Set_String(NewEnt, EV_SZ_classname, "vexd_tripmine")

  ENT_SetModel(NewEnt, "models/v_tripmine.mdl")
	Entvars_Set_Int(NewEnt, EV_INT_body, 3)
	Entvars_Set_Int(NewEnt, EV_INT_sequence, 7)	// 7 = TRIPMINE_WORLD

	new Float:MinBox[3]
	new Float:MaxBox[3]

	MinBox[0] = -8.0
	MinBox[1] = -8.0
	MinBox[2] = -8.0
	MaxBox[0] = 8.0
	MaxBox[1] = 8.0
	MaxBox[2] = 8.0

	Entvars_Set_Vector(NewEnt, EV_VEC_mins, MinBox)
	Entvars_Set_Vector(NewEnt, EV_VEC_maxs, MaxBox)

	new Float:vNewOrigin[3]
	new Float:vNormal[3]
	new Float:vTraceDirection[3]
	new Float:vTraceEnd[3]
	new Float:vTraceResult[3]
	new Float:vEntAngles[3]

	VelocityByAim(id, 64, vTraceDirection)
	
	vTraceEnd[0] = vTraceDirection[0] + vOrigin[0]
	vTraceEnd[1] = vTraceDirection[1] + vOrigin[1]
	vTraceEnd[2] = vTraceDirection[2] + vOrigin[2]

	TraceLn(id, vOrigin, vTraceEnd, vTraceResult)

	if(TraceNormal(id, vOrigin, vTraceEnd, vNormal) == 0) {
		RemoveEntity(NewEnt)
		console_print(id, "[TripMines] You must plant the tripmine on a wall!")
		return PLUGIN_HANDLED_MAIN
	}


	vNewOrigin[0] = vTraceResult[0] + (vNormal[0] * 8.0)
	vNewOrigin[1] = vTraceResult[1] + (vNormal[1] * 8.0)
	vNewOrigin[2] = vTraceResult[2] + (vNormal[2] * 8.0)

	ENT_SetOrigin(NewEnt, vNewOrigin)
	VecToAngles(vNormal, vEntAngles)

	Entvars_Set_Vector(NewEnt, EV_VEC_angles, vEntAngles)


	new Float:vBeamEnd[3]
	new Float:vTracedBeamEnd[3]
	vBeamEnd[0] = vNewOrigin[0] + (vNormal[0] * 8192)
	vBeamEnd[1] = vNewOrigin[1] + (vNormal[1] * 8192)
	vBeamEnd[2] = vNewOrigin[2] + (vNormal[2] * 8192)
	TraceLn(-1, vNewOrigin, vBeamEnd, vTracedBeamEnd)
	Entvars_Set_Vector(NewEnt, EV_VEC_vuser1, vTracedBeamEnd)

	Entvars_Set_Int(NewEnt, EV_INT_solid, 2)    //2 = Solid bbox. (const.h)
	Entvars_Set_Int(NewEnt, EV_INT_movetype, 5) //5 = movetype_fly, No grav, but collides.

	//Entvars_Set_Edict(NewEnt, EV_ENT_owner, id)
	Entvars_Set_Int(NewEnt, EV_INT_iuser2, 0) //0 Will be for inactive.
	Entvars_Set_Int(NewEnt, EV_INT_iuser3, id)

	emit_sound(NewEnt, CHAN_WEAPON, "weapons/mine_deploy.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	emit_sound(NewEnt, CHAN_VOICE, "weapons/mine_charge.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

	new args[4]
	num_to_str(NewEnt, args, 4)

	set_task(3.0, "TripMineActivate", 0, args, 4)

	mines[id]++

	return PLUGIN_HANDLED_MAIN
}

public TripMineActivate(MineID[]) {
	new EntID = str_to_num(MineID)
	
	new Float:vOrigin[3]
	Entvars_Get_Vector(EntID, EV_VEC_origin, vOrigin)

	new Float:vEnd[3]
	Entvars_Get_Vector(EntID, EV_VEC_vuser1, vEnd)

	message_begin(MSG_BROADCAST,SVC_TEMPENTITY) 
	write_byte(0)
	write_coord(floatround(vOrigin[0]))
	write_coord(floatround(vOrigin[1]))
	write_coord(floatround(vOrigin[2]))
	write_coord(floatround(vEnd[0])) //Random
	write_coord(floatround(vEnd[1])) //Random
	write_coord(floatround(vEnd[2])) //Random
	write_short(beam)
	write_byte(0)
	write_byte(0)
	write_byte(10) //Life
	write_byte(5) //Width
	write_byte(0)
	write_byte(255) // r
	write_byte(0) // g
	write_byte(0) // b
	write_byte(200)
	write_byte(0)
	message_end() 

	Entvars_Set_Int(EntID, EV_INT_iuser2, 1) //1 Will be for active.
	emit_sound(EntID, CHAN_VOICE, "weapons/mine_activate.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
}

public TripMineThink() {
	new iCurrent
	iCurrent = FindEntity(-1, "vexd_tripmine")

	while(iCurrent > 0) {
	if(Entvars_Get_Int(iCurrent, EV_INT_iuser2) == 1) {
		new Float:vOrigin[3]
		Entvars_Get_Vector(iCurrent, EV_VEC_origin, vOrigin)

		new Float:vEnd[3]
		Entvars_Get_Vector(iCurrent, EV_VEC_vuser1, vEnd)

		new Float:vTrace[3]
		new iHit
		iHit = TraceLn(iCurrent, vOrigin, vEnd, vTrace)

		if(iHit > 0) {
			new szClassName[32]
			Entvars_Get_String(iHit, EV_SZ_classname, szClassName, 32);
			
			if(equal(szClassName, "player")) {
				message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
				write_byte(99) //99 = KillBeam
				write_short(iCurrent)
				message_end()

				message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
				write_byte(3)
				write_coord(floatround(vOrigin[0]))
				write_coord(floatround(vOrigin[1]))
				write_coord(floatround(vOrigin[2]))
				write_short(boom)
				write_byte(50)
				write_byte(15)
				write_byte(0)
				message_end()

				blowUp(Entvars_Get_Int(iCurrent, EV_INT_iuser3), vOrigin) 

				RemoveEntity(iCurrent)
			}
		}
	}
	iCurrent =  FindEntity(iCurrent, "vexd_tripmine")
	}
}

public LaserThink() {
	new iCurrent
	iCurrent = FindEntity(-1, "vexd_tripmine")

	while(iCurrent > 0) {
		if(Entvars_Get_Int(iCurrent, EV_INT_iuser2) == 1) {
			new Float:vOrigin[3]
			Entvars_Get_Vector(iCurrent, EV_VEC_origin, vOrigin)

			new Float:vEnd[3]
			Entvars_Get_Vector(iCurrent, EV_VEC_vuser1, vEnd)

			message_begin(MSG_BROADCAST,SVC_TEMPENTITY) 
			write_byte(0)
			write_coord(floatround(vOrigin[0]))
			write_coord(floatround(vOrigin[1]))
			write_coord(floatround(vOrigin[2]))
			write_coord(floatround(vEnd[0])) //Random
			write_coord(floatround(vEnd[1])) //Random
			write_coord(floatround(vEnd[2])) //Random
			write_short(beam)
			write_byte(0)
			write_byte(0)
			write_byte(11) //Life
			write_byte(5) //Width
			write_byte(0)
			write_byte(255) // r
			write_byte(0) // g
			write_byte(0) // b
			write_byte(200)
			write_byte(0)
			message_end() 
		}

		iCurrent =  FindEntity(iCurrent, "vexd_tripmine")
	}
}

public reset_hud(id)
{
	mines[id]=0
}

public plugin_init(){ 
    register_plugin("Vexd TripMine","1.00","default") 
    register_concmd("amx_setmine", "Vexd_CreateMine", 0, ": plant a tripmine")
    register_cvar("amx_minesnum", "1")
    register_cvar("amx_minemaxdmg", "75")
    register_cvar("amx_mineradius", "100")

    register_event("ResetHUD", "reset_hud", "be")

    gMsgDeathMsg = get_user_msgid("DeathMsg")

    set_task(0.01, "TripMineThink", 0, "", 0, "b")
    set_task(1.0, "LaserThink", 0, "", 0, "b")
}

public plugin_precache() {
	precache_sound("weapons/mine_deploy.wav")
	precache_sound("weapons/mine_charge.wav")
	precache_sound("weapons/mine_activate.wav")
	precache_model("models/v_tripmine.mdl")
	beam = precache_model("sprites/laserbeam.spr")
	boom = precache_model("sprites/zerogxplode.spr")
}
