/*------------------------------------------------------------------------------ 
Admin Login (c) 2003, v!p3r.gTs 
Version: Alpha 0.9.12 
This file is provided as is (no warranties). 

Original Source: 
   admin.sma (0.9.6f) (c) 2003, OLO 
-------------------------------------------------------------------------------- 
WARNING: 
   Since this plugin is in a debugging phase, you are advised to backup 
   your user.ini. Also, you should use it at your own risk. 
-------------------------------------------------------------------------------- 
Description: 
   This plugin allows admins to login in game without writing their 
   passwords to config files(config.cfg). It's especially useful for admins 
   who always connect from public computers. 

   Admins passwords must be specified in users.ini, and the account flags 
   must NOT contain "e"(password is not checked), otherwise amx_login would not
   take effect. Currently admins can ONLY login with their (tags)usernames.
   Authid and IP are not allowed. 

   Notice that if amx_mode is set to "2", or account flags contain "a", 
   admins have to change their names to whatever but not the real username 
   so that they wont be kicked when connecting if passwords do not present 
   in config.cfg. 

Console Command: 
   amx_login <username> <password> 
   amx_logout
------------------------------------------------------------------------------*/ 

#include <amxmod> 
#include <amxmisc> 

#define MAX_ADMINS 64 

new data_password[MAX_ADMINS][32] 
new data_username[MAX_ADMINS][32] 
new data_flags[MAX_ADMINS] 
new data_access[MAX_ADMINS] 
new data_adminNum 
new amx_logFile[16] 
new bool:isAdmin[32] 

public plugin_init() { 
   register_plugin("Admin Login", "Alpha 0.9.12", "v!p3r.gTs") 
   register_cvar("amx_mode", "1.0") 
   register_cvar("amx_default_access", "") 
   register_concmd("amx_login", "admin_login", 0, "<username> <password>") 
   register_concmd("amx_logout", "admin_logout", 0, "- admin logout") 
   get_logfile(amx_logFile, 15) 
} 

public admin_logout(id) {
      if (isAdmin[id]) { 
         new defaccess[32] 
         get_cvar_string("amx_default_access", defaccess, 31) 
         new idefaccess = read_flags(defaccess) 
         if (idefaccess) { 
            set_user_flags(id, idefaccess) 
         } 
	 client_cmd(id, "echo ^"* Logout Successful!^"") 
         client_cmd(id, "echo ^"* Privileges Reset!^"") 
      }
      else {
         client_cmd(id, "echo ^"* You are not logged in as an admin!^"") 
      } 
      isAdmin[id] = false 
      return PLUGIN_HANDLED 
}

public admin_login(id, level, cid) { 
   if (!cmd_access(id, level, cid, 3)) 
      return PLUGIN_HANDLED 

   new user_name[32] 
   new user_pwd[32] 
   read_argv(1, user_name, 31) 
   read_argv(2, user_pwd, 31) 

   remove_user_flags(0, read_flags("z")) 

   if (isAdmin[id]) {
         client_cmd(id, "echo ^"* You are already logged in as an admin!^"") 
         client_cmd(id, "echo ^"* Type amx_logout to log out!^"") 
	 isAdmin[id] = true
         return PLUGIN_HANDLED
   }

   new filename[64] 
   get_basedir(filename, 31) 
   format(filename, 63, "%s/users.ini", filename) 

   if (!file_exists(filename)) 
      return PLUGIN_HANDLED 

   new szText[256], szFlags[32], szAccess[32] 
   new a, pos = 0 

   while (data_adminNum < MAX_ADMINS && read_file(filename, pos++, szText, 255, a)) { 
      if (szText[0] == ';') 
         continue 
      if (parse(szText, data_username[data_adminNum], 31, data_password[data_adminNum], 31, szAccess, 31, szFlags, 31) < 2) 
         continue 
      data_access[data_adminNum] = read_flags(szAccess) 
      data_flags[data_adminNum] = read_flags(szFlags) 
      ++data_adminNum 
   } 

   remove_user_flags(id) 
   new user_ip[32], user_authid[32] 
   get_user_ip(id, user_ip, 31, 1) 
   get_user_authid(id, user_authid, 31) 
   new result = getAccess(id, user_name, user_authid, user_ip, user_pwd) 
   if (result & 1) {
      client_cmd(id, "echo ^"* Login Not Allowed!^"") 
      return PLUGIN_HANDLED 
   }
   if (result & 2) {
      client_cmd(id, "echo ^"* Invalid Password!^"") 
      return PLUGIN_HANDLED 
   }
   if (result & 4) { 
      client_cmd(id, "echo ^"* Login Failed!^"") 
      return PLUGIN_HANDLED 
   } 
   if (result & 8) 
      client_cmd(id, "echo ^"* Password Accepted!^"") 
   if (result & 16) 
      client_cmd(id, "echo ^"* Privileges Set!^"") 
   return PLUGIN_HANDLED 
} 

getAccess(id, name[], authid[], ip[], password[]) { 
   new index = -1 
   new result = 0 
   for(new i = 0; i < data_adminNum; ++i) { 
      if (data_flags[i] & FLAG_TAG) { 
         if (contain(name, data_username[i]) != -1) { 
            index = i 
            break 
         } 
      } 
      else if (equal(name, data_username[i])) { 
         index = i 
         break 
      } 
      else { 
         client_cmd(id, "echo ^"* No such admin account!^"") 
         break
      } 
   } 
   if (index != -1) { 
      if (data_flags[index] & FLAG_NOPASS) { 
         isAdmin[id] = false 
         result |= 5 
         log_to_file(amx_logFile, "Login: ^"%s<%d><%s><>^" login failed - found account flag: ^"e^" (account ^"%s^") (address ^"%s^") ", name, get_user_userid(id), authid, data_username[index], ip) 
      } 
      else if (equal(password, data_password[index])) { 
         isAdmin[id] = true 
         result |= 24 
         set_user_flags(id, data_access[index]) 
         new sflags[32] 
         get_flags(data_access[index], sflags, 31) 
         log_to_file(amx_logFile, "Login: ^"%s<%d><%s><>^" become an admin (account ^"%s^") (access ^"%s^") (address ^"%s^")", name, get_user_userid(id), authid, data_username[index], sflags, ip) 
      } 
      else { 
         isAdmin[id] = false 
         result |= 2 
         if (data_flags[index] & FLAG_KICK) { 
            result |= 4 
            log_to_file(amx_logFile, "Login: ^"%s<%d><%s><>^" login failed - invalid password (account ^"%s^") (address ^"%s^")", name, get_user_userid(id), authid, data_username[index], ip) 
         } 
      } 
   } 
   else if (get_cvar_float("amx_mode") == 2.0) { 
      isAdmin[id] = false 
      result |= 4 
   } 
   else { 
      isAdmin[id] = false 
      new defaccess[32] 
      get_cvar_string("amx_default_access", defaccess, 31) 
      new idefaccess = read_flags(defaccess) 
      if (idefaccess) { 
         result |= 16 
         set_user_flags(id, idefaccess) 
      } 
   } 
   return result 
} 

public client_infochanged(id) { 
   if (!is_user_connected(id) || !get_cvar_num("amx_mode")) 
      return PLUGIN_CONTINUE 
   if (isAdmin[id]) { 
      client_cmd(id, "echo ^"* Privileges reset due to name change.^"") 
      client_print(id, print_chat, "* Privileges reset due to name change.") 
      isAdmin[id] = false 
   } 
   return PLUGIN_HANDLED 
}
