// AMX Mod script - Advanced Glow by Shawn
#include <amxmod>
#include <fun>
//<----------------------------- Advanced Glow Configuration Area ----------------------------------------->
// Please, just put 1 or 0 here ( 1=on & 0=off )
#define AUTOBOTSGLOW 1 // bots auto-glow at round start
#define AUTOHUMANSGLOW 0 // humans auto-glow at round start, this commands disable the glow menu
#define AUTOTEAMSGLOW 1 // the auto-glow are set by teams ( you must set auto-humans OR/AND auto-bots glow )
#define ALTERNATEGLOW 1 // when you are in random glow you're color is change every 5 seconds ( works only with glow menu )
#define FLAMEMODE 0 // the glow-shell looks like flame
#define GHOSTS 0 // when you glow, you look like a ghost
#define FX_EFFECTS 1 // ScreenFade when you start glowing ( works only with glow menu [not in random glow] )
#define SOUNDS_EVENTS 1 // play a sound when you start glowing ( doesn't works with auto-bots glow )
#define PRINT_EVENTS 1 // print in the chat all the glow events
//<----------------------------- Advanced Glow Configuration Area ----------------------------------------->

#if FLAMEMODE
new flame = 255
#endif
#if !FLAMEMODE
new flame = 16
#endif

#if GHOSTS
new ghosts = kRenderTransAdd
#endif
#if !GHOSTS
new ghosts = kRenderNormal
#endif

#if FX_EFFECTS && !AUTOHUMANSGLOW
new ScrFade
#endif

public plugin_init()
{
	register_plugin("Advanced_Glow","0.1","Shawn")
#if !AUTOHUMANSGLOW
	register_concmd("say","handle_say",0)
	register_menucmd(register_menuid("Glow Menu"),(1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<8)|(1<<9),"glow_menu")
#endif
#if AUTOBOTSGLOW
	register_logevent("glowing_bots",2,"0=World triggered","1=Round_Start")
#endif
#if AUTOHUMANSGLOW
	register_logevent("glowing_humans",2,"0=World triggered","1=Round_Start")
#endif
#if FX_EFFECTS && !AUTOHUMANSGLOW
ScrFade = get_user_msgid("ScreenFade")
#endif
}

#if SOUNDS_EVENTS
public plugin_precache()
{
	precache_sound("tentacle/te_alert1.wav")
	#if !AUTOHUMANSGLOW
	precache_sound("turret/tu_die.wav")
	#endif
}
#endif

#if !AUTOHUMANSGLOW
public glow_menu(id,key)
{
	#if PRINT_EVENTS
	new name[32]
	get_user_name(id,name,31)
	#endif
	switch(key){
	case 0:
	{
		#if ALTERNATEGLOW
		remove_task(id)
		#endif
		set_user_rendering(id,kRenderFxGlowShell,255,0,0,ghosts,flame)
		#if SOUNDS_EVENTS
		emit_sound(id,CHAN_ITEM,"tentacle/te_alert1.wav",VOL_NORM,ATTN_NORM,0,PITCH_NORM)
		#endif
		#if PRINT_EVENTS
		client_print(0,print_chat,"[AMX] %s is glowing red",name)
		#endif
		#if FX_EFFECTS
		message_begin(MSG_ONE,ScrFade,{0,0,0},id)
		write_short(1<<12) // fade lasts this long duration
		write_short(1<<8) // fade lasts this long hold time
		write_short(1<<1) // fade type OUT
		write_byte(255) // fade red
		write_byte(0) // fade green
		write_byte(0) // fade blue
		write_byte(200) // fade alpha
		message_end()
		#endif
	}
	case 1:
	{
		#if ALTERNATEGLOW
		remove_task(id)
		#endif
		set_user_rendering(id,kRenderFxGlowShell,0,0,255,ghosts,flame)
		#if SOUNDS_EVENTS
		emit_sound(id,CHAN_ITEM,"tentacle/te_alert1.wav",VOL_NORM,ATTN_NORM,0,PITCH_NORM)
		#endif
		#if PRINT_EVENTS
		client_print(0,print_chat,"[AMX] %s is glowing blue",name)
		#endif
		#if FX_EFFECTS
		message_begin(MSG_ONE,ScrFade,{0,0,0},id)
		write_short(1<<12)
		write_short(1<<8)
		write_short(1<<1)
		write_byte(0)
		write_byte(0)
		write_byte(255)
		write_byte(200)
		message_end()
		#endif
	}
	case 2:
	{
		#if ALTERNATEGLOW
		remove_task(id)
		#endif
		set_user_rendering(id,kRenderFxGlowShell,0,255,0,ghosts,flame)
		#if SOUNDS_EVENTS
		emit_sound(id,CHAN_ITEM,"tentacle/te_alert1.wav",VOL_NORM,ATTN_NORM,0,PITCH_NORM)
		#endif
		#if PRINT_EVENTS
		client_print(0,print_chat,"[AMX] %s is glowing green",name)
		#endif
		#if FX_EFFECTS
		message_begin(MSG_ONE,ScrFade,{0,0,0},id)
		write_short(1<<12)
		write_short(1<<8)
		write_short(1<<1)
		write_byte(0)
		write_byte(255)
		write_byte(0)
		write_byte(200)
		message_end()
		#endif
	}
	case 3:
	{
		#if ALTERNATEGLOW
		remove_task(id)
		#endif
		set_user_rendering(id,kRenderFxGlowShell,128,255,255,ghosts,flame)
		#if SOUNDS_EVENTS
		emit_sound(id,CHAN_ITEM,"tentacle/te_alert1.wav",VOL_NORM,ATTN_NORM,0,PITCH_NORM)
		#endif
		#if PRINT_EVENTS
		client_print(0,print_chat,"[AMX] %s is glowing like ice",name)
		#endif
		#if FX_EFFECTS
		message_begin(MSG_ONE,ScrFade,{0,0,0},id)
		write_short(1<<12)
		write_short(1<<8)
		write_short(1<<1)
		write_byte(128)
		write_byte(255)
		write_byte(255)
		write_byte(200)
		message_end()
		#endif
	}
	case 4:
	{
		#if ALTERNATEGLOW
		remove_task(id)
		#endif
		set_user_rendering(id,kRenderFxGlowShell,255,255,0,ghosts,flame)
		#if SOUNDS_EVENTS
		emit_sound(id,CHAN_ITEM,"tentacle/te_alert1.wav",VOL_NORM,ATTN_NORM,0,PITCH_NORM)
		#endif
		#if PRINT_EVENTS
		client_print(0,print_chat,"[AMX] %s is glowing yellow",name)
		#endif
		#if FX_EFFECTS
		message_begin(MSG_ONE,ScrFade,{0,0,0},id)
		write_short(1<<12)
		write_short(1<<8)
		write_short(1<<1)
		write_byte(255)
		write_byte(255)
		write_byte(0)
		write_byte(200)
		message_end()
		#endif
	}
	case 5:
	{
		#if ALTERNATEGLOW
		remove_task(id)
		#endif
		set_user_rendering(id,kRenderFxGlowShell,255,128,255,ghosts,flame)
		#if SOUNDS_EVENTS
		emit_sound(id,CHAN_ITEM,"tentacle/te_alert1.wav",VOL_NORM,ATTN_NORM,0,PITCH_NORM)
		#endif
		#if PRINT_EVENTS
		client_print(0,print_chat,"[AMX] %s is glowing pink",name)
		#endif
		#if FX_EFFECTS
		message_begin(MSG_ONE,ScrFade,{0,0,0},id)
		write_short(1<<12)
		write_short(1<<8)
		write_short(1<<1)
		write_byte(255)
		write_byte(128)
		write_byte(255)
		write_byte(200)
		message_end()
		#endif
	}
	case 6:
	{
		#if ALTERNATEGLOW
		remove_task(id)
		#endif
		set_user_rendering(id,kRenderFxGlowShell,128,0,255,ghosts,flame)
		#if SOUNDS_EVENTS
		emit_sound(id,CHAN_ITEM,"tentacle/te_alert1.wav",VOL_NORM,ATTN_NORM,0,PITCH_NORM)
		#endif
		#if PRINT_EVENTS
		client_print(0,print_chat,"[AMX] %s is glowing purple",name)
		#endif
		#if FX_EFFECTS
		message_begin(MSG_ONE,ScrFade,{0,0,0},id)
		write_short(1<<12)
		write_short(1<<8)
		write_short(1<<1)
		write_byte(128)
		write_byte(0)
		write_byte(255)
		write_byte(200)
		message_end()
		#endif
	}
	case 7:
	{
		#if ALTERNATEGLOW
		remove_task(id)
		#endif
		set_user_rendering(id,kRenderFxGlowShell,random_num(0,255),random_num(0,255),random_num(0,255),ghosts,flame)
		#if ALTERNATEGLOW && !AUTOHUMANSGLOW
		set_task(5.0,"irandom",id,"",0,"b")
		#endif
		#if SOUNDS_EVENTS
		emit_sound(id,CHAN_ITEM,"tentacle/te_alert1.wav",VOL_NORM,ATTN_NORM,0,PITCH_NORM)
		#endif
		#if PRINT_EVENTS
		client_print(0,print_chat,"[AMX] %s is glowing a random color",name)
		#endif
	}
	case 8:
	{
		#if ALTERNATEGLOW
		remove_task(id)
		#endif
		set_user_rendering(id,kRenderFxNone,0,0,0,kRenderNormal,16)
		#if SOUNDS_EVENTS
		emit_sound(id,CHAN_ITEM,"turret/tu_die.wav",VOL_NORM,ATTN_NORM,0,PITCH_NORM)
		#endif
		#if PRINT_EVENTS
		client_print(0,print_chat,"[AMX] %s is not glowing anymore",name)
		#endif
		}
	}
	return PLUGIN_HANDLED
}
#endif

#if !AUTOHUMANSGLOW
public menu_glowing(id)
{
	new menu_body[512]
	copy(menu_body,511,"\yGlow Menu^n\w^n\%1. Glow Red\w^n\%2. Glow Blue\w^n\%3. Glow Green\w^n\%4. Glow Ice\w^n\%5. Gow Yellow\w^n\%6. Glow Pink\w^n\%7. Glow Purple\w^n\%8. Glow Random\w^n\%9. Glow Off\w^n^n0. Exit")
	show_menu(id,(1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<8)|(1<<9),menu_body)
	return PLUGIN_HANDLED
}
#endif

#if ALTERNATEGLOW && !AUTOHUMANSGLOW
public irandom(id)
{
if (is_user_alive(id) == 1){
set_user_rendering(id,kRenderFxGlowShell,random_num(0,255),random_num(0,255),random_num(0,255),ghosts,flame)
/* this part is comment, to prevent sound & chat spamming, uncomment if you like spam message...
#if PRINT_EVENTS
client_print(id,print_chat,"[AMX] You're glowing an other color")
#endif
#if SOUNDS_EVENTS
emit_sound(id,CHAN_ITEM,"tentacle/te_alert1.wav",VOL_NORM,ATTN_NORM,0,PITCH_NORM)
#endif
*/
}
else if (is_user_alive(id) == 0){
remove_task(id)
}
return PLUGIN_CONTINUE
}
#endif

#if AUTOBOTSGLOW
public glowing_bots()
{
	#if AUTOTEAMSGLOW
	new players[32], inum
	new tplayers[32], tinum
	#endif
	#if !AUTOTEAMSGLOW
	new players[32], inum
	#endif

	#if AUTOTEAMSGLOW
	get_players(players,inum,"dae","CT")
	for(new a=0;a<inum;++a)
	set_user_rendering(players[a],kRenderFxGlowShell,0,0,255,ghosts,flame)

	get_players(tplayers,tinum,"dae","TERRORIST")
	for(new i=0;i<tinum;++i)
	set_user_rendering(tplayers[i],kRenderFxGlowShell,255,0,0,ghosts,flame)

	#if PRINT_EVENTS
	if(inum>0 && tinum>0){
	client_print(0,print_chat,"[AMX] All bots are glowing according to there colors teams")
	}
	#endif

	#endif

	#if !AUTOTEAMSGLOW
	get_players(players,inum,"da")
	for(new a=0;a<inum;++a)
	set_user_rendering(players[a],kRenderFxGlowShell,random_num(0,255),random_num(0,255),random_num(0,255),ghosts,flame)

	#if PRINT_EVENTS
	if(inum>0){
	client_print(0,print_chat,"[AMX] All bots are glowing a random color")
	}
	#endif

	#endif
	return PLUGIN_HANDLED
}
#endif

#if AUTOHUMANSGLOW
public glowing_humans()
{
	#if AUTOTEAMSGLOW
	new players[32], inum
	new tplayers[32], tinum
	#endif
	#if !AUTOTEAMSGLOW
	new players[32], inum
	#endif

	#if AUTOTEAMSGLOW
	get_players(players,inum,"cae","CT")
	for(new a=0;a<inum;++a)
	set_user_rendering(players[a],kRenderFxGlowShell,0,0,255,ghosts,flame)

	#if SOUNDS_EVENTS
	get_players(players,inum,"cae","CT")
	for(new s=0;s<inum;++s)
	emit_sound(players[s],CHAN_ITEM,"tentacle/te_alert1.wav",VOL_NORM,ATTN_NORM,0,PITCH_NORM)
	#endif

	get_players(tplayers,tinum,"cae","TERRORIST")
	for(new i=0;i<tinum;++i)
	set_user_rendering(tplayers[i],kRenderFxGlowShell,255,0,0,ghosts,flame)

	#if SOUNDS_EVENTS
	get_players(tplayers,tinum,"cae","TERRORIST")
	for(new s=0;s<tinum;++s)
	emit_sound(tplayers[s],CHAN_ITEM,"tentacle/te_alert1.wav",VOL_NORM,ATTN_NORM,0,PITCH_NORM)
	#endif

	#if PRINT_EVENTS
	if(inum>0 && tinum>0){
	client_print(0,print_chat,"[AMX] All humans are glowing according to there colors teams")
	}
	#endif

	#endif

	#if !AUTOTEAMSGLOW
	get_players(players,inum,"ca")
	for(new a=0;a<inum;++a)
	set_user_rendering(players[a],kRenderFxGlowShell,random_num(0,255),random_num(0,255),random_num(0,255),ghosts,flame)

	#if SOUNDS_EVENTS
	get_players(players,inum,"ca")
	for(new s=0;s<inum;++s)
	emit_sound(players[s],CHAN_ITEM,"tentacle/te_alert1.wav",VOL_NORM,ATTN_NORM,0,PITCH_NORM)
	#endif

	#if PRINT_EVENTS
	if(inum>0){
	client_print(0,print_chat,"[AMX] All humans are glowing a random color")
	}
	#endif

	#endif
	return PLUGIN_HANDLED
}
#endif

#if !AUTOHUMANSGLOW
public handle_say(id,key)
{
	new said[31]
	new cmd[9]
	read_args(said,30)
	replace(said,30,"^"","")
	parse(said,cmd,8,key,21)
	if (equal(cmd,"glow",8)){
	if (is_user_alive(id) == 1){
	menu_glowing(id)
	}
	else
	client_print(id,print_chat,"[AMX] You Can't Glow when you are dead.")
	}
	return PLUGIN_CONTINUE
}
#endif
