/***************************************************************************
*  amx_ejl_logallsay.sma
*   version 1.2            Date: 10/29/2002
*   Author: Eric Lidman     ejlmozart@hotmail.com
*   Alias: Ludwig van       Upgrade: http://lidmanmusic.com/cs/plugins.html
*
*  Its simple really, no commands, it just logs everything said on the
*   server to a single file every day. Everything includes admin_tsay etc.
*   It writes in the format:
*
*    month/date/year time  command(like say)  authid   name   what was said
*
*  Setup:
*   Important: For the logging to work, you need to set up some folders
*   on your server. You need: ../%moddir%/admin_logs/say_logs
*
*     example:      ../cstrike/admin_logs/say_logs
*
***************************************************************************/


#include <amxmod>

#define MAX_MAP_NAME		32
#define MAX_LOG_LINE		192
#define MAX_FILE_NAME		100
#define MAX_USER_ID			32
#define MAX_COMMAND_LENGTH 	16

#if !defined NO_STEAM
#define MAX_AUTH_ID			33
#else
#define MAX_AUTH_ID			17
#endif

#if !defined NO_STEAM
new logPath[] = "%Y-%m-%d--allsay.log"
#else
new logPath[] = "admin_logs/say_logs/%Y-%m-%d--allsay.log"
#endif

new fileLogName[MAX_FILE_NAME]

public plugin_init() {
   register_plugin("EJL Log all say","1.3","EJL")
   register_concmd("amx_tsay", "HandleSay")
   register_concmd("amx_csay", "HandleSay")
   register_concmd("amx_fsay", "HandleSay")
   register_concmd("amx_scrollsay","HandleSay")
   register_concmd("amx_tsayy", "HandleSay")
   register_concmd("amx_csayy", "HandleSay")
   register_concmd("amx_fsayy", "HandleSay")
   register_concmd("amx_scrollsayy","HandleSay")
   register_concmd("tsay", "HandleSay")
   register_concmd("csay", "HandleSay")
   register_concmd("fsay", "HandleSay")
   register_concmd("scrollsay","HandleSay")
   register_concmd("tsayy", "HandleSay")
   register_concmd("csayy", "HandleSay")
   register_concmd("fsayy", "HandleSay")
   register_concmd("scrollsayy","HandleSay")
   register_concmd("psay", "HandleSay")
   register_concmd("amx_chat", "HandleSay")
   register_concmd("amx_say", "HandleSay")
   register_concmd("amx_psay", "HandleSay")
   register_concmd("amx_vote", "HandleSay")
   register_concmd("amx_mymotd","HandleSay")
   register_clcmd("say_team", "HandleSay")
   register_clcmd("say", "HandleSay")

   register_srvcmd("botsay","handle_botsayplugin")

   new ThisMap[MAX_MAP_NAME]
   new saylog[MAX_LOG_LINE]

   get_mapname(ThisMap,MAX_MAP_NAME - 1)
   get_time(logPath,fileLogName,MAX_FILE_NAME - 1)
   format(saylog,MAX_LOG_LINE - 1,"START MAP:  %s",ThisMap)
   log_to_file(fileLogName, saylog)

   return PLUGIN_CONTINUE
}

public handle_botsayplugin(){
   new arg0[8]
   read_argv(1,arg0,7)
   new iarg0 = strtonum(arg0)
   new sarg2[MAX_LOG_LINE]
   read_args(sarg2,MAX_LOG_LINE-1)
   new arg1[8]
   read_argv(2,arg1,7)
   new iarg1 = strtonum(arg1)
   if(is_user_bot(iarg1)){
      new OnlySay[128]
      new CMD[8]
      new len = strlen(sarg2)
      new start = contain(sarg2,":    ")
      copy(OnlySay,len-start+5,sarg2[start+5])
      copy(CMD,6,"BOTSAY")
      if(HandleSay2(iarg1,CMD,OnlySay))
      	server_cmd("botsayreturn %d 1",iarg0)
   }

   return PLUGIN_CONTINUE
}

public HandleSay(id){
   new Speech[MAX_LOG_LINE]
   new Command[MAX_COMMAND_LENGTH]

   read_argv(0,Command,MAX_COMMAND_LENGTH - 1)
   read_args(Speech,MAX_LOG_LINE - 1)
   remove_quotes(Speech)

   HandleSay2(id,Command,Speech)

   return PLUGIN_CONTINUE
}

HandleSay2(id,Command[],Speech[]){
   new User[MAX_USER_ID]
   new AUTHID[MAX_AUTH_ID]

   get_user_authid(id,AUTHID,MAX_AUTH_ID - 1)
   get_user_name(id,User,MAX_USER_ID - 1)

   log_to_file(fileLogName, "%s %s ........ %s .................. %s", Command, AUTHID, User, Speech)

   return PLUGIN_CONTINUE
}

