/* 
Ghoster Threat Detector, v1.0 FINAL 
By CvaX <mrjosh123@sbcglobal.net> 

NOTES 
=====
Formerly known as "LAN Threat Detector", this is a plugin that helps admins detect possible Ghosters (LAN cheaters). It checks for players 
with the same IP address and displays a HUD Message warning players of about them 

USAGE 
===== 
amx_ghost - Run Ghoster Threat Detector
amx_glowghosters <1|0> - Enable/Disable glowing of Potential Ghosters
amx_ghostersmotd <1|0> - Enable/Disable MOTD screens displayed by this plugin (Ghoster List/Ghoster Help)
amx_ghosterscam <1|0> - Enable/Disable Force Chase Cam when Potential Ghosters Detected
say /ghost - Run Ghoster Threat Detector 
say /ghosters - Displays MOTD screen of Potential Ghosters
say /glowghosters - Glows Potential Ghosters till end of round
say /ghosthelp - Displays a MOTD screen of help

VERSIONS 
======== 
version 0.1: Checks for same IP amoung 2 players connected to server upon admin request 
version 0.2: Checks IPs whenever someone connects 
version 0.3: Added - Renaming LAN players from "Player" to "[LAN]Player" capability 
version 0.4: Added - Sound alerts along with the HUD alerts 
version 0.5: Fixed Bug - Naming issue with spaces in players names 
version 0.6: Fixed Issue - Alert annonucement issues 
version 0.7: Fixed Bug - Detecting only 2 players on LAN at a time 
			 Fixed Bug - Detecting only 1 LAN at a time 
			 Added - MOTD Screen that displays list of Ghosters 
			 Removed - Renaming of players
			 Changed - Renamed plugin from "LAN Threat Detector" to "Ghoster Threat Detector"
			 Changed - Modified sounds played in alerts
			 Changed - Cvars renamed: "amx_lan" to "amx_ghost" and "say /lan" to "say /ghost"
version 0.8: Added - Glowing of ghosters upon request
			 Added - Help MOTD screen
			 Added - Cvars: "amx_glowghosters", "amx_ghostersmotd", "say /glowghosters", "say /ghosthelp"
version 0.9: Added - Renaming of ghosters upon request
			 Added - Cvars: "amx_ghostersrename", "say /renameghosters"
version 1.0: Added - Force chase cam features
			 Added - Cvars: "amx_ghosterscam"


*/ 

#include <amxmod> 
#include <amxmisc> 
#include <fun>

new concheck,sayghost,ghostbusters,ghosthelp,sayrename
new glowenable=1
new motdenable=1
new rename=0
new cam=1
new camcvar=0


public amx_lan(id){ 
	new players[32]                              //index of players 
	new numplayers,i,x                           //number of total players 
	new ips[32][16]                              //array of player IPs

	new lan_total 
	new lan_total_real 
	new lanplay_total 
	new lan_ids[16][33]							//ids for each LAN. lan_ids[0][1] holds the ID of the second person in the first LAN (the '0' corresponds to the LAN number (goes from 0 -> 15) and the '1' to the id).
	new number_in_lan[16]						//number_in_lan[] holds the number of people in a specific LAN. number_in_lan[7] will return the number of people in the 8th LAN.
	new lan_number[16] = { -1,...}				//lan_number[] holds the number of the LAN of a certain id. lan_number[3] would hold the LAN number of a user with id '3'. If user is not in a LAN, it holds '-1'. 

	new glowcolor

	//add "c" to skip BOTS
	get_players(players,numplayers,"c") 

	//creates 2d array of player IPs 
	for(i=0;i<numplayers;i++){ 
		get_user_ip(players[i],ips[i],16,1) 
	} 
    
	for(i=0;i<numplayers;i++){ 
		if((lan_number[players[i]]>=0) && i) 
			continue 
		for(x=1;x<numplayers;x++){ 
			new id1 = players[i], id2 = players[x] 
			if(lan_number[id2] >=0) 
				continue 
			if( equal(ips[i],ips[x]) ){ 
				if(lan_number[id1] == -1){ 
					lan_ids[lan_total][number_in_lan[lan_total]++]=id1
					lan_number[id1] = lan_total++ 
					if(i!=x){
						lan_ids[lan_number[id1]][number_in_lan[lan_number[id1]]++] = id2 
						lan_number[id2] = lan_number[id1]
					}
				} else {
					lan_ids[lan_number[id1]][number_in_lan[lan_number[id1]]++] = id2 
					lan_number[id2] = lan_number[id1]
				}	
			} 
		}
	}

	for(x=0;x<lan_total;x++){ 
		if(number_in_lan[x]>=2){ 
			lan_total_real++ 
			lanplay_total=lanplay_total+number_in_lan[x]
		} 
	} 
	
	//RENAMING SYSTEM
	if(sayrename==1){
		if(rename==0){
			set_hudmessage(39, 57, 122, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2)
			show_hudmessage(id,"Ghoster Renaming is currently disabled.")
			sayrename=0 
			return PLUGIN_HANDLED
		}
		new tempname[32],tempname2[32]
		new z,y
		for(z=0;z<lan_total;z++){
			if(number_in_lan[z]>2){
				for(y=0;y<number_in_lan[z];y++){
					get_user_name(lan_ids[z][y],tempname,31)
					get_user_name(lan_ids[z][y],tempname2,31)
					if(tempname[0]!='[' && tempname[1]!='L' && tempname[2]!='A' && tempname[3]!='N' && tempname[4]!=']'){
						client_cmd(lan_ids[z][y],"name ^"[LAN]%s^"",tempname2)
					}
				}
			}
		}
		set_hudmessage(39, 57, 122, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2)
		show_hudmessage(id,"Potential Ghosters renamed.")
		sayrename=0
		return PLUGIN_HANDLED
	}

	//GHOSTERS MOTD HELP
	if(ghosthelp==1){
		if(motdenable==0){
			set_hudmessage(39, 57, 122, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2)
			show_hudmessage(id,"Ghoster Help is currently disabled.")
			ghosthelp=0 
			return PLUGIN_HANDLED
		}
		new help[1000]
		new temphelp[400]
		temphelp="Commands Available^n\
			amx_ghost <- Run Ghoster Threat Detector^n\
			say /ghost <- Run Ghoster Threat Detector^n\
			say /ghosters <- Displays MOTD screen of Potential Ghosters^n\
			say /glowghosters <- Glows Potential Ghosters till end of round^n\
			say /ghosthelp <- Displays MOTD screen of help^n\
			say /renameghosters <- Renames Potential Ghosters^n^n"
		add(help,999,temphelp)
		temphelp="Admin Cvars^n\
			amx_glowghosters <1|0> <- Enable/Disable glowing of Potential Ghosters^n\
			amx_ghostersmotd <1|0> <- Enable/Disable MOTD screen used by this plugin^n\
			amx_ghostersrename <1|0> <- Enable/Disable renaming of Potential Ghosters^n\
			amx_ghosterscam <1|0> <- Enable/Disable Force Chase Cam when Potential Ghosters Detected^n^n"
		add(help,999,temphelp)
		format(temphelp,399,"^n^n^n\
				Ghost Threat Detector v1.0 by CvaX")
		add(help,2047,temphelp)
		show_motd(id,help,"Ghoster Threat Detector Help")
		ghosthelp=0 
		return PLUGIN_HANDLED
	}

	//GHOSTERS MOTD DISPLAY
	if(sayghost==1){
		if(motdenable==0){
			set_hudmessage(39, 57, 122, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2)
			show_hudmessage(id,"Ghoster List is currently disabled.")
			sayghost=0 
			return PLUGIN_HANDLED
		}
		new message[2048]
		new temp[400]
		new tempname[32]
		new z,y
		if(lan_total_real==0){
			format(temp,399,"There are no potential Ghosters at the moment.^n^n^n\
					Ghost Threat Detector v1.0 by CvaX")
			add(message,2047,temp)
			show_motd(id,message,"Ghoster Threat")
		} else {
			format(temp,399,"This is a list of all Potential Ghosters.^n^n")
			add(message,2047,temp)
			for(z=0;z<lan_total;z++){
				if(number_in_lan[z]>2){
					new abc=z+1
					format(temp,399,"LAN^n",abc)
					add(message,2047,temp)
					for(y=0;y<number_in_lan[z];y++){
						get_user_name(lan_ids[z][y],tempname,31)
						format(temp,399,"%s^n",tempname)
						add(message,2047,temp)
					}
					format(temp,399,"^n")
					add(message,2047,temp)
				}
			}
			format(temp,399,"^n^n^n\
					Ghost Threat Detector v1.0 by CvaX")
			add(message,2047,temp)
			show_motd(id,message,"Ghoster Threat Detected")
			
		} 
		sayghost=0 
		return PLUGIN_HANDLED 
	}

	//GLOWING SYSTEM
	if(ghostbusters==1){
		new z,y
		if(glowenable==0){
			set_hudmessage(39, 57, 122, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2)
			show_hudmessage(0,"Glowing of Potential Ghosters is now Disabled.")
			for(z=0;z<lan_total;z++){
				if(number_in_lan[z]>2){
					for(y=0;y<number_in_lan[z];y++)
							set_user_rendering(lan_ids[z][y],kRenderFxGlowShell,0,0,0,kRenderTransAlpha,255)
				}
			}
			ghostbusters=0 
			return PLUGIN_HANDLED
		}
		if(lan_total_real==0){
			set_hudmessage(39, 57, 122, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2) 
			show_hudmessage(id,"Ghoster Threat not Detected. Nobody is glowing.")
			
		} else {
			for(z=0;z<lan_total;z++){
				if(number_in_lan[z]>2){
					for(y=0;y<number_in_lan[z];y++){
						if(glowcolor==0)
							set_user_rendering(lan_ids[z][y],kRenderFxGlowShell,255,0,0,kRenderTransAlpha,255)
						else if(glowcolor==1)
							set_user_rendering(lan_ids[z][y],kRenderFxGlowShell,255,255,0,kRenderTransAlpha,255)
						else if(glowcolor==2)
							set_user_rendering(lan_ids[z][y],kRenderFxGlowShell,255,0,255,kRenderTransAlpha,255)
						else if(glowcolor==3)
							set_user_rendering(lan_ids[z][y],kRenderFxGlowShell,0,255,0,kRenderTransAlpha,255)
						else if(glowcolor==4)
							set_user_rendering(lan_ids[z][y],kRenderFxGlowShell,0,255,255,kRenderTransAlpha,255)
						else if(glowcolor==5)
							set_user_rendering(lan_ids[z][y],kRenderFxGlowShell,0,0,255,kRenderTransAlpha,255)
						else if(glowcolor==6)
							set_user_rendering(lan_ids[z][y],kRenderFxGlowShell,255,255,255,kRenderTransAlpha,255)
					}
				}
			}
			if(glowcolor==6)
				glowcolor=0
			else
				glowcolor++
			set_hudmessage(237, 27, 50, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2) 
			show_hudmessage(0,"Potential Ghosters are now glowing till end of round.")
		} 
		ghostbusters=0 
		return PLUGIN_HANDLED 
	}

	//FORCECHASE CAM MODE SYSTEM
	if(camcvar==1){
		if(lan_total_real>0){
			if(cam==0){
				set_cvar_num("mp_forcechasecam",0)
				set_hudmessage(0,255,0, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2)
				show_hudmessage(0,"Ghoster Force Chase Cam Set to 0")
			}
			else{
				set_hudmessage(0,255,0, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2)
				show_hudmessage(0,"Ghoster Force Chase Cam Set to 2")
				set_cvar_num("mp_forcechasecam",2)
			}
		}
		camcvar=0
		return PLUGIN_HANDLED
	}


	//HUD MESSAGE DISPLAY SYSTEM
	if(lan_total_real==0 && concheck==0){ 
		set_hudmessage(39, 57, 122, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2) 
		show_hudmessage(id,"Ghoster Threat not Detected") 
		client_cmd(id,"spk misc/GhosterNoDetect.wav") 
	}else{ 
		if(lan_total_real==1 && concheck==1 && number_in_lan[lan_number[id]]>=2){         //Ghosters connecting 
			set_hudmessage(237, 27, 50, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2) 
			show_hudmessage(0,"Ghoster Threat Detected. %i Potential Ghosters on %i LAN. Type /ghosters for list.",lanplay_total,lan_total_real) 
			client_cmd(0,"spk misc/GhosterDetect.wav") 
			
		}else if(lan_total_real>1 && concheck==1 && number_in_lan[lan_number[id]]>=2){ 
			set_hudmessage(237, 27, 50, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2) 
			show_hudmessage(0,"Ghoster Threat Detected. %i Potential Ghosters on %i LANs. Type /ghosters for list.",lanplay_total,lan_total_real) 
			client_cmd(0,"spk misc/GhosterDetect.wav") 

		}else if(lan_total_real==1){        //Ghosters detected upon player connect 
			set_hudmessage(237, 27, 50, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2) 
			show_hudmessage(id,"Ghoster Threat Detected. %i Potential Ghosters on %i LAN. Type /ghosters for list.",lanplay_total,lan_total_real) 
			client_cmd(id,"spk misc/GhosterDetect.wav") 

		}else if(lan_total_real>1){        //Ghosters detected upon player connect 
			set_hudmessage(237, 27, 50, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2) 
			show_hudmessage(id,"Ghoster Threat Detected. %i Potential Ghosters on %i LANs. Type /ghosters for list.",lanplay_total,lan_total_real) 
			client_cmd(id,"spk misc/GhosterDetect.wav") 
		}
	}
	concheck=0

	return PLUGIN_CONTINUE 
} 

public say_ghoster(id){ 
   sayghost=1 
   amx_lan(id) 
} 

public ghost_help(id){
	ghosthelp=1
	amx_lan(id)
}

public say_ghostbusters(id){
	ghostbusters=1
	amx_lan(id)
}

public say_rename(id){
	sayrename=1
	amx_lan(id)
}

public lan_check(id){ 
   concheck=1 
   amx_lan(id) 
} 

public client_connect(id)
{
	client_cmd(id, "echo ;echo ^"This server is protected against Ghosters. Type /ghosthelp for help.^"")
	return PLUGIN_CONTINUE
}

public client_putinserver(id){ 
   lan_check(id) 
} 

public plugin_precache() { 
   precache_sound("misc/GhosterNoDetect.wav") 
   precache_sound("misc/GhosterDetect.wav") 
   return PLUGIN_CONTINUE 
} 

public glow_ghoster(id,level,cid){
	if(!cmd_access(id,level,cid,2)) 
		return PLUGIN_HANDLED
	new arg[32]
	read_argv(1,arg,32)
	if(strtonum(arg)==1)
		glowenable=1
	else
		glowenable=0
	say_ghostbusters(id)
	return PLUGIN_HANDLED
}

public motd_ghoster(id,level,cid){
	if(!cmd_access(id,level,cid,2)) 
		return PLUGIN_HANDLED
	new arg[32]
	read_argv(1,arg,32)
	if(strtonum(arg)==1)
		motdenable=1
	else
		motdenable=0
	return PLUGIN_HANDLED
}

public rename_ghoster(id,level,cid){
	if(!cmd_access(id,level,cid,2)) 
		return PLUGIN_HANDLED
	new arg[32]
	read_argv(1,arg,32)
	if(strtonum(arg)==1)
		rename=1
	else
		rename=0
	say_rename(id)
	return PLUGIN_HANDLED
}

public ghost_cam(id,level,cid){
	if(!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[32]
	read_argv(1,arg,32)
	if(strtonum(arg)==1)
		cam=1
	else
		cam=0
	camcvar=1
	amx_lan(id)
	return PLUGIN_HANDLED
}

public plugin_init(){ 
   register_plugin("Ghoster Threat Detector","1.0","CvaX")
   register_concmd("amx_ghost","amx_lan",0,"- Run Ghoster Threat Detector") 
   register_clcmd("say /ghost","amx_lan",0,"- Run Ghoster Threat Detector") 
   register_clcmd("say /ghosters","say_ghoster",0,"- Displays MOTD screen of Potential Ghosters")
   register_clcmd("say /glowghosters","say_ghostbusters",0,"- Glows Potential Ghosters till end of round")
   register_clcmd("say /ghosthelp","ghost_help",0,"- Displays a MOTD screen of help")
   register_clcmd("say /renameghosters","say_rename",0,"- Renames Potential Ghosters")
   register_concmd("amx_glowghosters","glow_ghoster",ADMIN_VOTE,"<1|0> - Enable/Disable glowing of Potential Ghosters")
   register_concmd("amx_ghostersmotd","motd_ghoster",ADMIN_VOTE,"<1|0> - Enable/Disable MOTD screen displayed by this plugin")
   register_concmd("amx_ghostersrename","rename_ghoster",ADMIN_VOTE,"<1|0> - Enable/Disable renaming of Potential Ghosters")
   register_concmd("amx_ghosterscam","ghost_cam",ADMIN_VOTE,"<1|0> - Enable/Disable Force Chase Cam when Potential Ghosters Detected")
   return PLUGIN_CONTINUE 
} 
