/*
Ropes Controller, v0.4
By CvaX

NOTES
=====
This is a basic plugin that helps admins control two famous ropes plugins out there.
	Ninja Rope from SpaceDude and HookMod4 from Drunken F00l
This plugin requires the installation of Johnny got his gun's Vote Access Plugin.

VOTING
======
Please use Johnny got his gun's Vote Access Plugin.
It can be obtained here at this url http://amxmod.net/forums/viewtopic.php?t=16984&highlight=vote+access+plugin
To use this plugin for voting please add these two lines to your (listen)server.cfg

	amx_voteaccess "ninjarope" "Ninja Rope?" "Yes please" "amx_rope_ninja 1" "No thank you" "amx_rope_ninja 0"
	amx_voteaccess "hookrope" "Hook Rope?" "Yes please" "amx_rope_hook 1" "No thank you" "amx_rope_hook 1"

USAGE
=====
amx_rope_ninja <1|0> - Enable/Disable Ninja Rope Usage
amx_rope_hook <1|0> - Enable/Disable Hook Rope Usage
say /ninjarope - Displays a MOTD on how to use the Ninja Rope
say /hookrope - Displays a MOTD on how to use the Hook Rope
say vote ninjarope - Starts a vote for enabling/disabling Ninja Rope
say vote hookrope - Starts a vote for enabling/disabling Hook Rope

VERSIONS
========
version 0.1: Ninja Rope On/Off with amx_rope_ninja
version 0.2: added Hook Rope On/Off with amx_rope_hook
version 0.3: added HUD announcements on activation/deactivation of both Ninja Rope & Hook Rope
version 0.4: added voting support


*/

#include <amxmod>
#include <amxmisc>

public amx_rope_ninja(id,level,cid){
	if(!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[32]
	read_argv(1,arg,32)
	server_cmd("sv_ninjarope %s",arg)
	if(strtonum(arg)){
		set_hudmessage(39, 57, 122, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2)
		show_hudmessage(0,"Ninja Rope Enabled: Type /ninjarope to learn how to use^n\
				Type ^"vote ninjarope^" to turn on/off")
	}
	else{
		set_hudmessage(39, 57, 122, 0.1, 0.60, 1, 1.0, 4.0, 0.1, 0.2, 2)
		show_hudmessage(0,"Ninja Rope Disabled^n\
				Type ^"vote ninjarope^" to turn on/off")
	}
	return PLUGIN_CONTINUE
}

public amx_rope_hook(id,level,cid){
	if(!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[32]
	read_argv(1,arg,32)
	server_cmd("DF_hook_on %s",arg)
	if(strtonum(arg)){
		new message[]="Hook Rope Enabled: Type /hookrope to learn how to use^n\
				Type ^"vote hookrope^" to turn on/off"
		set_hudmessage(237, 27, 50, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2)
		show_hudmessage(0,message)
	}
	else{
		set_hudmessage(237, 27, 50, 0.1, 0.60, 1, 1.0, 4.0, 0.1, 0.2, 2)
		show_hudmessage(0,"Hook Rope Disabled^n\
				Type ^"vote hookrope^" to turn on/off")
	}
	return PLUGIN_HANDLED
}

public say_ninjarope(id){
	new message[]="To use the Ninja Rope first bind a key to the command +rope^n^n\
		Ex. bind ^"mouse3^" ^"+rope^"^n^n\
		Usage: Hold the bound button to launch rope.^n\
			Holding Jump key will shorten the rope.^n\
			Holding Crouch will make the rope longer.^n\
			Directional keys will allow you to swing on the rope.^n^n^n\
		Ninja Rope From SpaceDude's Ninja Rope Plugin^n^n^n\
		Ropes Controller by CvaX"
	show_motd(id,message,"Ninja Rope")
	return PLUGIN_CONTINUE
}

public say_hookrope(id){
	new message[]="To use the Hook Rope first bind a key to the command +hook^n^n\
		Ex. bind ^"mouse3^" ^"+hook^"^n^n\
		Usage: hold the bound key to launch the hook, you will automatically begin climbing up the hook rope.^n^n^n\
		Hook Rope from Drunken F00l's Hook Mod 4^n^n^n\
		Ropes Controller by CvaX"
	show_motd(id,message,"Hook Rope")
	return PLUGIN_CONTINUE
}

public plugin_init(){
	register_plugin("Ropes Controller","0.4","CvaX")
	register_concmd("amx_rope_ninja","amx_rope_ninja",ADMIN_LEVEL_G,"<1|0> - Enable/Disable Ninja Rope Usage")
	register_concmd("amx_rope_hook","amx_rope_hook",ADMIN_LEVEL_G,"<1|0> - Enable/Disable Hook Usage")
	register_clcmd("say /ninjarope","say_ninjarope",0,"- Displays a MOTD on how to use the Ninja Rope")
	register_clcmd("say /hookrope","say_hookrope",0,"-Displays a MOTD on how to use the Hook Rope") 
	return PLUGIN_CONTINUE
}
