/*
Timed Admin, v0.3
By CvaX <mrjosh123@sbcglobal.net>

NOTES
=====
This is a plugin that allows servers to control the time that certain admins have powers.

REQUIREMENTS
============
This plugin requires Ludwig van's Grant_Remove_Admin plugin. You can obtain it from here
http://amxmod.net/amx-plugins.php?cat=search#62796

USAGE
=====
say /admintime - Tells you your admin status
Use the cfg file "timedadmin.cfg" to add admins on to the clock.
The format is:
	183052    <--- Wonid
	0000      <--- Admin Start time (HH:MM)
	2400      <--- Admin End time (HH:MM)
	bcdef     <--- Admin access level

VERSIONs
========
version 0.1: Grants admin access to users on the timedadmin.cfg if circumstances are correct
version 0.2: Added say /admintime command
version 0.3: Added sound alerts to be played along with the HUD messages

FUTURE
======
Remove admin command when the admins time is up. (currently it is set at when admin disconnects/quits)

KNOWN ISSUES
============
When compiling there will be 19 WARNINGS. Just ignore them.


*/


#include <amxmod>
#include <amxmisc>

new flags2[32]
new tba[2],tbb[2],tbc[2],tbd[2],tea[2],teb[2],tec[2],ted[2]
new admin=0
new admin2=0

public client_putinserver(id){
	timed_admin(id)
}

public timed_admin(id){
	new message[27],timebegin[5],timeend[5],ctime[5],name[32]
	new len,line=0, steamid[32]
	get_user_authid(id, steamid, 31)
	if(file_exists("addons/amx/timedadmin.cfg")==1){
		while(read_file("addons/amx/timedadmin.cfg",line++,message,26,len)){
			if(equal(message, steamid)){
				read_file("addons/amx/timedadmin.cfg",line++,timebegin,4,len)
				read_file("addons/amx/timedadmin.cfg",line++,timeend,4,len)
				get_time("%H%M",ctime,4)
				read_file("addons/amx/timedadmin.cfg",line++,flags2,31,len)
				if(strtonum(timebegin)<strtonum(ctime)<strtonum(timeend)){
					get_user_name(id,name,31)
					server_cmd("amx_makeadmin ^"%s^" ^"%s^"",name,flags2)
					admin=1
				} else {
					tba[0]=timebegin[0];tbb[0]=timebegin[1];tbc[0]=timebegin[2];tbd[0]=timebegin[3]
					tea[0]=timeend[0];teb[0]=timeend[1];tec[0]=timeend[2];ted[0]=timeend[3]
					admin=0
					admin2=1
				}
			}
		}
	}
	return PLUGIN_CONTINUE
}

public say_admintime(id){
	if(admin==1 && flags2[0]!='a'){
		set_hudmessage(38, 175, 110, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2)
		show_hudmessage(id,"It is your time. You have been given admin access %s without immunity.",flags2)
		client_cmd(id,"spk misc/admingranted.wav") 
	} else if(admin==1 && flags2[0]=='a'){
		set_hudmessage(38, 175, 110, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2)
		show_hudmessage(id,"It is your admin time. You have been given admin access %s with immunity.",flags2)
		client_cmd(id,"spk misc/admingranted.wav") 
	}
	
	if(admin==0 && admin2==1){
		set_hudmessage(237, 27, 50, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2)
		show_hudmessage(id,"You are only admin from %s%s:%s%s and %s%s:%s%s.",tba,tbb,tbc,tbd,tea,teb,tec,ted)
		client_cmd(id,"spk misc/admindenied.wav") 
	} else if(admin==0 && admin2==0){
		set_hudmessage(237, 27, 50, 0.1, 0.60, 1, 1.0, 7.0, 0.1, 0.2, 2)
		show_hudmessage(id,"You are not an admin.")
		client_cmd(id,"spk misc/admindenied.wav")
	}
}

public plugin_precache() { 
	precache_sound("misc/admingranted.wav") 
	precache_sound("misc/admindenied.wav")
	return PLUGIN_CONTINUE 
}

public plugin_init(){
	register_plugin("Timed Admin","0.3","CvaX")
	register_clcmd("say /admintime","say_admintime",0,"- Tells you your admin status")
	return PLUGIN_CONTINUE
}
