
/* AMX Mod script. 
* 
* (c) Copyright 2002, Rouven <rouven@kiez-clan.de> 
*                              http://www.kiez-clan.de 
* 
* Shows available maps in amx_menu 
* You may want to change the sql statement to your desires.
* If you like to show official maps only, than change the statement on line 66 to:
* SELECT map FROM amx_availmaps WHERE official=1
*
* Or maybe u want to do a special wintercycle, than change special on all specific maps to 1 and
* modify your statement like this:
* SELECT map FROM amx_availmaps WHERE special=1
* 
* This file is provided as is (no warranties). 
* 
* 
*/ 

/*

This AMX plugin requires MySQL MetaSmall module.

For this to work, you might create your MySQL admins table with this SQL query :

CREATE TABLE amx_availmaps (
  map_id tinyint(4) NOT NULL auto_increment,
  map varchar(32) NOT NULL default '',
  official char(1) NOT NULL default '0',
  special char(1) NOT NULL default '0',
  PRIMARY KEY  (map_id),
  UNIQUE KEY map_id (map_id),
  UNIQUE KEY map (map)
) TYPE=MyISAM;


IMPORTANT:
o check $moddir/addons/amx/mysql.cfg for MySQL access configuration
o you still need menu.cfg config file, but you can remove maps ("amx_amenu" lines)
o maps left there will still be loaded

*/

#include <amxmod>
#include <mysql>

public maps_sql()
{ 
   new mysql,cnt 
   new map[32] 
   new error[257] 
   new host[65] 
   new user[33] 
   new pass[33] 
   new db[33] 
    
   get_cvar_string("amx_mysql_host",host,64) 
   get_cvar_string("amx_mysql_user",user,32) 
   get_cvar_string("amx_mysql_pass",pass,32) 
   get_cvar_string("amx_mysql_db",db,32) 
	
   mysql = mysql_connect(host,user,pass,db,error,256) 
   
   if(mysql>0) 
   { 
       	if(mysql_query(mysql,"SELECT map FROM amx_availmaps")>0) 
      	{ 
         cnt = 0 
         while(mysql_nextrow(mysql)>0) 
         { 
		mysql_getfield(mysql,1,map,32)
		server_cmd("amx_amenu ^"%s^"",map)
	        cnt++ 
         } 
         server_print("[AMX] Loaded %d map(s) from database",cnt) 
      	} 
      	else 
      	{ 
         mysql_error(mysql,error,32) 
         server_print("MySQL error : could not load map : '%s'",error) 
      } 
      mysql_close(mysql) 
   } 
   else 
   { 
      server_print("MySQL error : could not connect : '%s'",error) 
   } 
    
   return PLUGIN_HANDLED 
} 


public plugin_init(){
	register_plugin("Available Maps from MySQL","0.1","Rouven")
	register_srvcmd("amx_sqlmaps","maps_sql")
	register_cvar("amx_mysql_host","127.0.0.1")
	register_cvar("amx_mysql_user","root")
	register_cvar("amx_mysql_pass","")
	register_cvar("amx_mysql_db","amx")
	server_cmd("exec addons/amx/mysql.cfg;amx_sqlmaps")
	return PLUGIN_CONTINUE
}

