/*
*  AMX Mod script.
*
* (c) Copyright 2003, ST4life
* This file is provided as is (no warranties).
*/

#include <amxmod>
#include <amxmisc>

/*
* "DefinedNames" is a plugin to examine players names. It checks for player authid and its name.
* is it another name than in the list it will show a menu to him to choose one.
*
* For more Information please read the dn_readme.txt of the zip-file at attachment of the plugin-
* forum-post: http://amxmod.net/forums/viewtopic.php?t=8160
*/

#define MAX_NAMES   64
#define MAX_USERS   32

new names_authid[MAX_USERS][32]
new names_flag[MAX_USERS][32]
new names_original[MAX_USERS][32]
new names_fake1[MAX_USERS][32]
new names_fake2[MAX_USERS][32]
new names_na[MAX_NAMES][32]
new names_num = 0
new names_na_num = 0
new bool:name_check[33]

/*******************************************************************************
** initialize plugin                                                          **
*******************************************************************************/

public plugin_init(){
   register_plugin("DefinedNames","1.1","ST4life")
   register_menucmd(register_menuid("Choose Name"),1023,"act_menu")
   register_srvcmd("dn_config_text","setConfigText")
   register_concmd("amx_dn_listfakers","list_fakers",0,"- displays players from dn_nameslist")
   register_concmd("amx_dn_changename","admin_changename",0,"< name/ip/authid target > < 1/2/3 or nick >")
   register_event("ResetHUD","check_names","b")
   register_cvar("amx_dn_sopen","1")
   register_cvar("amx_dn_na","0")
   register_cvar("amx_dn_ifnick","[N/A name]")
   register_cvar("amx_dn_newnick","change your nick please!")
   load_settings("addons/amx/dn_nameslist.ini")
   load_na_settings("addons/amx/dn_na_nameslist.ini")
   server_cmd("exec addons/amx/definednames.cfg");
   return PLUGIN_CONTINUE
}

/*******************************************************************************
** set text-configuration                                                     **
*******************************************************************************/

new config_text[13][128]
new config_text_num = 0
public setConfigText(){
    read_argv(1,config_text[config_text_num],127)
    config_text_num++
    return PLUGIN_HANDLED
}

/*******************************************************************************
** reading files                                                              **
*******************************************************************************/

load_settings(filename[]){
    if(!file_exists(filename)) return 0
    new namesline[256], a, line = 0
    while(names_num < MAX_USERS && read_file(filename,line++,namesline,255,a)){
        if(namesline[0] == ';') continue
        if(parse(namesline,names_authid[names_num],31,names_flag[names_num],1,
           names_original[names_num],31,names_fake1[names_num],31,
           names_fake2[names_num],31) < 3) continue

        ++names_num
    }
    server_print("[DefinedNames] Namelist loaded (%d names)",names_num)
    return 1
}

load_na_settings(filename[]){
    if(!file_exists(filename)) return 0
    new nanamesline[256], a, line = 0
    while(names_na_num < MAX_NAMES && read_file(filename,line++ ,nanamesline,255,a)){
        if (nanamesline[0] == ';') continue
        if (parse(nanamesline,names_na[names_na_num],31) < 1) continue

        ++names_na_num
    }
    server_print("[DefinedNames] NA-namelist loaded (%d names)",names_na_num)
    return 1
}

/*******************************************************************************
** register client connect / show if server is closed for registered users    **
*******************************************************************************/

public client_connect(id){
   new name[33], authid[32]
   get_user_authid(id,authid,31)
   if(names_num == 0){
      set_cvar_num("amx_dn_sopen",1)
      server_print("[DefinedNames] Reset CVAR amx_dn_sopen to 1, because there is no entry in Names-List!")
   }
   if (get_cvar_num("amx_dn_sopen") == 0){


      client_cmd(id,"echo ^"%s^"",config_text[1])
      new index = -1
      for(new i = 0; i < names_num; ++i) {
         if (equal(authid,names_authid[i])) {
            index = -1
            break
         } else {
            index = i
         }
      }
      if (index != -1) {
         client_cmd(id,"echo ^"%s^";disconnect",config_text[2])
      }
   } else {
      client_cmd(id,"echo ^"%s^"",config_text[0])
   }
   get_user_name(id,name,32)
   check_connectname(id,name,authid)
   return PLUGIN_CONTINUE
}

/*******************************************************************************
** register name change                                                       **
*******************************************************************************/

public client_infochanged(id){
   if (is_user_connected(id)){
      new newname[33], oldname[33], authid[32]
      get_user_info(id,"name",newname,32)
      get_user_name(id,oldname,32)
      get_user_authid(id,authid,31)
      if(names_num > 0){
         check_namechanged(id,newname,oldname,authid)
      }
      if (get_cvar_num("amx_dn_na") > 0){
         check_names_na(id,newname,authid)
      }
   }
}

/*******************************************************************************
** check name on connect                                                      **
*******************************************************************************/

public check_connectname(id,username[],userauthid[]){
   new index = -1
   for(new i = 0; i < names_num; ++i) {
      if (equal(userauthid,names_authid[i])) {
         index = i
         break
      }
   }
   if (index != -1) {
      if (contain(names_flag[index],"a") != -1){
         if (!equal(username,names_original[index])) {
            set_user_info(id,"name",names_original[index])
         }
      }
      if (contain(names_flag[index],"b") != -1) {
         if (!equal(username,names_original[index])&&!equal(username,names_fake1[index])&&
             !equal(username,names_fake2[index])){
            set_user_info(id,"name",names_original[index])
         }
      }
      if (contain(names_flag[index],"c") != -1) {
         // do nothing
      }
   }
   return PLUGIN_CONTINUE
}

/*******************************************************************************
** check namechange                                                           **
*******************************************************************************/

public check_namechanged(id,usernewname[],useroldname[],userauthid[]){
   new index = -1
   for(new i = 0; i <= names_num; ++i) {
      if (equal(userauthid,names_authid[i])) {
         if(!is_user_alive(id)){
            name_check[id]=false
            return PLUGIN_CONTINUE
         }
         index = i
         break
      }
   }
   if(name_check[id] == false){
      get_user_authid(id,userauthid,31)
   }
   if (index != -1) {
      if (contain(names_flag[index],"a") != -1) {
         if (!equal(usernewname,names_original[index])) {
            set_user_info(id,"name",names_original[index])
            client_print(id,print_chat,config_text[8])
         }
      }
      if (contain(names_flag[index],"b") != -1) {
         if(name_check[id] == false){
            get_user_info(id,"name",usernewname,32)
         }
         if (!equal(usernewname,names_original[index])&&!equal(usernewname,names_fake1[index])&&
             !equal(usernewname,names_fake2[index])) {
            new keys
            new text[513]
            if(equal(names_fake2[index],"")) {
               format(text, 512, "\yChoose Name: ^n^n\w1. %s^n2. %s",names_original[index],
                      names_fake1[index])
               keys = (1<<0)|(1<<1)
            } else {
               format(text, 512, "\yChoose Name: ^n^n\w1. %s^n2. %s^n3. %s",names_original[index],
                      names_fake1[index],names_fake2[index])
               keys = (1<<0)|(1<<1)|(1<<2)
            }
            show_menu(id, keys, text)
            set_user_info(id,"name",useroldname)
            client_print(id,print_chat,config_text[10])
            client_print(id,print_chat,config_text[11],names_original[index],names_fake1[index],
                         names_fake2[index])
            client_print(id,print_chat,config_text[12])
         }
      }
      if (contain(names_flag[index],"c") != -1) {
         // do nothing
      }
   }
   name_check[id]=true
   return PLUGIN_CONTINUE
}

/*******************************************************************************
** running menu command                                                       **
*******************************************************************************/

public act_menu(id,key) {
   new authid[32]
   get_user_authid(id,authid,31)
   new index = -1
   for(new i = 0; i < names_num; ++i) {
      if (equal(authid,names_authid[i])) {
         index = i
         break
      }
   }
   if (index != -1) {
      switch(key) {
         case 0: {
            set_user_info(id,"name",names_original[index])
            client_print(id,print_chat,"%s",config_text[9],names_original[index])
         }
         case 1: {
            set_user_info(id,"name",names_fake1[index])
            client_print(id,print_chat,"%s",config_text[9],names_fake1[index])
         }
         case 2: {
            set_user_info(id,"name",names_fake2[index])
            client_print(id,print_chat,"%s",config_text[9],names_fake2[index])
         }
      }
   }
   return PLUGIN_HANDLED
}

/*******************************************************************************
** to show choose menu only one time at round start                           **
*******************************************************************************/

public check_names(){
    new players[32], inum
    get_players(players,inum,"","")
    for(new i = 0 ;i < inum ;++i){
        if(name_check[players[i]] == false){
           check_namechanged(players[i],"0","0","0")
        }
    }
    return PLUGIN_CONTINUE
}

/*******************************************************************************
** check for not allowed nicks on name change (amx_dn_na has to be enabled!)  **
*******************************************************************************/

public check_names_na(id,usernewname[],userauthid[]){
   new dn_index = -1
   if(names_num > 0){
      for(new o = 0; o < names_num; ++o) {
         if (equal(userauthid,names_authid[o])) {
            break
         } else {
            dn_index = o
         }
      }
   }
   new index = -1
   for(new i = 0; i < names_na_num; ++i) {
      if(equali(usernewname,names_na[i])) {
         index = i
         break
      }
   }
   if ((index != -1)&&(dn_index != -1)){
      new chname[32], nickname[32], oldname[32], nick[32]
      switch(get_cvar_num("amx_dn_na")){
         case 2: {
                get_cvar_string("amx_dn_newnick",nick,31)
                set_user_info(id,"name",nick)
         }
         case 1: {
               get_cvar_string("amx_dn_ifnick",nick,31)
               get_user_info(id,"name",oldname,31)
               format(chname,31,"%s %s",nick,oldname)
               set_user_info(id,"name",chname)
         }
      }
      get_user_info(id,"name",nickname,31)
      client_print(id,print_chat,config_text[8])
      client_print(id,print_chat,config_text[9],nickname)
   }
   return PLUGIN_CONTINUE
}

/*******************************************************************************
** show fakers by command: amx_dn_listfakers                                  **
*******************************************************************************/

public list_fakers(id){
   if (!(get_user_flags(id)&ADMIN_IMMUNITY)){
      return PLUGIN_CONTINUE
   }
   new spieler[32]
   console_print(id,"  ")
   console_print(id,config_text[4])
   new inum
   new zaehler2 = 1
   get_players(spieler,inum,"","")
   for(new i = 0 ;i < inum ;++i){
      for(new o = 0; o < names_num; ++o) {
         new authid[32], name[33]
         get_user_authid(spieler[i],authid,31)
         get_user_name(spieler[i],name,32)
         if((equal(authid,names_authid[o]))&&(!equal(name,names_original[o]))){
            console_print(id,config_text[5],zaehler2,name,names_original[o])
            zaehler2++
         }
      }
   }
   console_print(id,"  ")
   return PLUGIN_CONTINUE
}

/*******************************************************************************
** Change name of user by admin command                                       **
*******************************************************************************/

public admin_changename(id){
   if (!(get_user_flags(id)&ADMIN_LEVEL_A)){
      client_print(id,print_chat,config_text[3])
      return PLUGIN_CONTINUE
   }
   new acn_target[33]
   new acn_to[33]
   read_argv(1,acn_target,32)
   read_argv(2,acn_to,32)
   new player = cmd_target(id,acn_target)
   if (!player){
      return PLUGIN_CONTINUE
   }
   new userauthid[32]
   get_user_authid(player,userauthid,31)
   new index = -1
   for(new i = 0; i < names_num; ++i) {
      if(equal(acn_target,names_authid[i])) {
         index = i
         break
      }
   }
   if (index != -1) {
      if (contain(acn_to,"1") != -1){
          set_user_info(player,"name",names_original[index])
      }
      if (contain(acn_to,"2") != -1){
          set_user_info(player,"name",names_fake1[index])
      }
      if (contain(acn_to,"3") != -1){
          set_user_info(player,"name",names_fake2[index])
      }
   } else {
      set_user_info(player,"name",acn_to)
   }
   client_print(id,print_chat,config_text[6])
   return PLUGIN_CONTINUE
}
