/* 
*    AMXMOD script. 
*    
*	Plugin : Delayed action
* 
*       by DanRaZor
* 
* New command : amx_delay "command/alias" "seconds"
*
*       sends the command/alias to the server console
*	delayed from specified time
*
*	ADMIN_RCON access needed
*/  

#include <amxmod> 
#include <amxmisc>

#define	TIMER		1.0
#define	MAX_TXT_LEN	150
#define	MAX_TXT_LEN_1	149

new	timer		= 0
new	actionToDo[MAX_TXT_LEN]
new 	waitingForNext	= 0

public show_remaining( ) {
	
	new text[MAX_TXT_LEN]
	
	if ( timer > 0 ) {
		format ( text , MAX_TXT_LEN_1 , "[ %s ]- %d second%s remaining",actionToDo,timer,timer>1 ? "s" : "" )
		set_hudmessage(0,80,220,0.05,0.7,0,TIMER,TIMER,0.1,0.1,9)
		show_hudmessage(0,text)
	}
	
	if ( timer == 0 ) {
		new text2[MAX_TXT_LEN]
		format ( text2 , MAX_TXT_LEN_1 , "[ %s ]- Done",actionToDo )
		set_hudmessage(0,80,220,0.05,0.7,0,2.0,2.0,0.1,0.1,9)
		show_hudmessage(0,text2)
		make_action()
		return PLUGIN_CONTINUE
	}
	else {
		set_task ( TIMER , "show_remaining" )
	}
	
	--timer
	
	return PLUGIN_CONTINUE
	
}

public make_action( ) {
	
	server_cmd ( actionToDo )
	
	for ( new i = 0 ; i < MAX_TXT_LEN ; ++i )
		actionToDo[i] = 0
		
	waitingForNext = 0
	timer = 0
	
	return PLUGIN_CONTINUE
}

public start_action( id , level, cid ) 
{
	if (!cmd_access(id,level,cid,3))
		return PLUGIN_HANDLED
	
	if ( waitingForNext == 1 ) {
		console_print(id,"[AMX] Already doing a delayed action, try later ..." )	
		return PLUGIN_HANDLED_MAIN	
	}		
	
	waitingForNext = 1
		
	new secs[30]
	read_argv(2,secs,29)
	
	read_argv(1,actionToDo,MAX_TXT_LEN_1)
	
	if ( actionToDo[0] == 0 ) {
        waitingForNext  = 0
		return PLUGIN_HANDLED_MAIN	
                }
	
	if ( secs[0] == 0 ) {
		make_action ( )
		return PLUGIN_HANDLED_MAIN
	}
	else {
		timer = strtonum ( secs )
		show_remaining ()		
	}
	
	return PLUGIN_HANDLED_MAIN
} 

public plugin_init() 
{ 
	waitingForNext = 0
	register_plugin	("Delayed action","1.0","DanRaZor") 
	register_concmd	("amx_delay" ,"start_action" ,ADMIN_RCON,"^"command/alias^" ^"seconds^"")
	return PLUGIN_CONTINUE 
}
