
/* AMX Mod script - dod_mirror_damage
*
*  Mirror Damage for DoD
*  Based on OLO's original Mirror Damage plugin for CS
*  Now uses SidLuke's dodstats module for damage info (much better than using health event)
*
*  Cvars (add these to amx.cfg):
*  
*  amx_mirrordamage <flags>
*  "a" - take health from attacker
*  "b" - give health back to victim
*  "c" - make attacker glow
*
*  amx_mirrordamage_time <seconds>
*    # - how long to mirror damage after player respawns (default = 10 seconds)
*    0 = mirror damage always on
*
*
*  e.g.
*  amx_mirrordamage "abc"
*  amx_mirrordamage_time 10
*
*/

#include <amxmod>
#include <fun>
#include <dodstats>

new player_check[33]
new iglow[33]
new damage_mode
new Float:check_time

public respawn_msg(id)
{
	iglow[id] = 0

	new flags[8]
	get_cvar_string("amx_mirrordamage",flags,7)
	damage_mode = read_flags(flags)
	check_time = get_cvar_float("amx_mirrordamage_time")

	if(check_time > 0)
	{
		player_check[id] = 1
		new param[3]
		param[0] = id
		set_task(check_time,"check_off",id,param,2)
	}

	return PLUGIN_CONTINUE 
}

public check_off(param[])
{
	new id = param[0]
	player_check[id] = 0
}

public damage_info(attacker,victim,damage,wpnindex,hitplace,TA)
{
	if (attacker==victim || !TA || (player_check[attacker]==0 && player_check[victim]==0) )
		return PLUGIN_CONTINUE

	if (damage_mode & 1)
		set_user_health(attacker, get_user_health(attacker) - damage)

	if (damage_mode & 2)
		set_user_health(victim, get_user_health(victim) + damage)

	if (damage_mode & 4)
	{
		if (iglow[attacker] < 1)
		{
			new param[3]
			param[0] = attacker
			set_task(0.4,"glow_change",0,param,2)
		}
		iglow[attacker] += 250
		set_user_rendering(attacker,kRenderFxGlowShell,iglow[attacker],0,0,kRenderNormal,16)
	}

	return PLUGIN_CONTINUE 
}

public glow_change(param[])
{
	new id = param[0]
	iglow[id] -= 25
	if (iglow[id] > 0)
	{
		set_user_rendering(id,kRenderFxGlowShell,iglow[id],0,0,kRenderNormal,16)
		set_task(0.4,"glow_change",0,param,2)
	}
	else
	{
		iglow[id] = 0
		set_user_rendering(id)
	}
}

public client_connect(id)
{
	if (check_time > 0)
		player_check[id] = 0
	else
		player_check[id] = 1
	return PLUGIN_CONTINUE 
}

public plugin_init()
{
	register_plugin("DoD Mirror Damage","0.9.4","Fractal")
	register_event("ResetHUD", "respawn_msg","b")
	register_cvar("amx_mirrordamage","abc")
	register_cvar("amx_mirrordamage_time","10")
	return PLUGIN_CONTINUE
}

