#include <amxmod>

// Self Explanatory -----
public Float:get_user_fpm(id) {

	return get_user_frags(id) * 60 / float(get_user_time(id,1));

}

// Display FPMs -----
public fpm(args[]) {

	new id = args[0];
	set_hudmessage(0,100,0,0.05,0.40,0,6.0,float(get_timeleft()),0.0,0.0,4);   
	show_hudmessage(id, "%i / %i  %.2f FPM - %d:%02d", get_user_frags(id), get_user_deaths(id), get_user_fpm(id), get_user_time(id,1)/60, get_user_time(id,1)%60 );
   
	return PLUGIN_CONTINUE;

}

// Turn FPM display off ------
public fpm_on(id) {

	new params[1];
	params[0] = id;
	set_task( 0.5, "fpm", id, params, 1, "b", 1 );

	return PLUGIN_HANDLED;

}

// Turn FPM display off -----
public fpm_off(id) {

	remove_task(id,0);
   
	set_hudmessage(0,100,0,0.05,0.40,0,6.0,float(get_timeleft()),0.0,0.0,4);   
	show_hudmessage(id, "" );
   
	return PLUGIN_HANDLED;

}

// Display leading 3 frags per minute -----
public top_three() {
	
	if( !( get_cvar_num("amx_fpm") ) )
		return PLUGIN_CONTINUE;

	new plist[32], num;
	get_players(plist, num, "c");

	if( num == 0 ) {
		
		return PLUGIN_CONTINUE;

	} else if( num == 1) {

		if( get_user_fpm(plist[0]) > 0 ) {
			new name[33];
			get_user_name(plist[0], name, 32);
			client_print(0, print_chat, "1. %s (%.2f fpm)", name, get_user_fpm(plist[0]));
		}

	} else if( num == 2) {

		new id[2], first[33], second[33];

		if( get_user_fpm(plist[0]) > get_user_fpm(plist[1]) ) {
			
			id[0] = plist[0];
			get_user_name(plist[0], first, 32);

			id[1] = plist[1];
			get_user_name(plist[1], second, 32);

		} else {
			
			id[0] = plist[1];
			get_user_name(plist[1], first, 32);

			id[1] = plist[0];
			get_user_name(plist[0], second, 32);
		}

		if( get_user_fpm(id[0]) > 0 ) {
			
			if( get_user_fpm(id[1]) > 0 ) {
				
				client_print(0, print_chat, "1. %s (%.2f fpm) 2. %s (%.2f fpm)", first, get_user_fpm(id[0]), second, get_user_fpm(id[1]) );

			} else {

				client_print(0, print_chat, "1. %s (%.2f fpm)", first, get_user_fpm(id[0]) );

			}
		}
		

	} else {

		new Float:one, Float:two, Float:three, id[3], first[33], second[33], third[33], i;
		one = -10.0;
		two = -10.0;
		three = -10.0;

		for(i=0; i<=num; i++) {
			
			if( get_user_fpm(plist[i]) > one ) {

				one = get_user_fpm(plist[i]);
				id[0] = plist[i];

			}

		}

		get_user_name(id[0], first, 32);

		for(i=0; i<=num; i++) {

			if( plist[i] != id[0] && get_user_fpm(plist[i]) > two ) {
				
				two = get_user_fpm(plist[i]);
				id[1] = plist[i];

			}

		}

		get_user_name(id[1], second, 32);

		for(i=0; i<=num; i++) {

			if( plist[i] != id[0] && plist[i] != id[1] && get_user_fpm(plist[i]) > three ) {
				
				three = get_user_fpm(plist[i]);
				id[2] = plist[i];

			}

		}

		get_user_name(id[2], third, 32);

		if( one > 0 ) {

			if( two > 0 ) {

				if( three > 0 ) {
					
					client_print(0, print_chat, "1. %s (%.2f fpm)  2. %s (%.2f fpm)  3. %s (%.2f fpm)", first, one, second, two, third, three);

				} else {

					client_print(0, print_chat, "1. %s (%.2f fpm)  2. %s (%.2f fpm)", first, one, second, two);

				}

			} else {

				client_print(0, print_chat, "1. %s (%.2f fpm)", first, one);

			}

		}

	}

	return PLUGIN_CONTINUE;

}

// Turn on Top 3 Display
public top3_on() {

	set_task( 45.0, "top_three", 37338, "", 1, "b", 1 );

	return PLUGIN_CONTINUE;

}

public client_disconnect(id) {

	fpm_off(id);
	
	return PLUGIN_CONTINUE;

}

public plugin_init() {
	
	register_plugin("FPM Script", "3.0", "Cult of the Dead Cow");
	
	register_clcmd("say /fpmon", "fpm_on", 0, "- Turn FPM Display On");
	register_clcmd("say /fpmoff", "fpm_off", 0, "- Turn FPM Display Off");
	
	register_cvar("amx_fpm", "1");

	top3_on();

	return PLUGIN_CONTINUE;

}
