/* AMX Mod script.
*
* Headshot 0.1
*  by SniperBeamer
*
*
* Description:
*  This plugin can change the damage multiplier for each hitzone.
*  It's like the MM plugin Headshot (coded by OLO), but you can modify the damage for each hitzone.
*
* CVARs:
*  Turn Headshot Mode on/off: (0/1)
*  hs_mode
*  Multiplier for hit zones: (0.0 to disable damage)
*  hs_head
*  hs_chest
*  hs_stomach
*  hs_larm
*  hs_rarm
*  hs_lleg
*  hs_rleg
*
* Requires the Vexd Utilities!
*
*/

//----------------------------------------------------------------------------------------------
#include <amxmod>
#include <fun>
#include <Vexd_Utilities>
//----------------------------------------------------------------------------------------------
new bool:hs_mode
new bool:last_mode
new Float:hs_head
new Float:hs_chest
new Float:hs_stomach
new Float:hs_larm
new Float:hs_rarm
new Float:hs_lleg
new Float:hs_rleg

new gmsgDeathMsg

new friend[33]
new bool:specmode[33]
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	register_plugin("Headshot","0.1","SniperBeamer")
	register_event("ResetHUD","reset_hud","b")
	register_event("Damage","damage_event","b","2!0")
	register_logevent("new_round",2,"0=World triggered","1=Round_Start")
	register_event("StatusValue","set_team","be","1=1")
	register_event("StatusValue","show_status","be","1=2","2!0")
	register_event("StatusValue","hide_status","be","1=1","2=0")
	register_event("TextMsg","set_specmode","bd","2&ec_Mod")
	register_event("StatusValue","show_position","bd","1=2")

	register_cvar("hs_mode","1")
	register_cvar("hs_head","1.0")
	register_cvar("hs_chest","1.0")
	register_cvar("hs_stomach","1.0")
	register_cvar("hs_larm","1.0")
	register_cvar("hs_rarm","1.0")
	register_cvar("hs_lleg","1.0")
	register_cvar("hs_rleg","1.0")
	register_cvar("headshot_version","0.1",FCVAR_SPONLY)

	gmsgDeathMsg = get_user_msgid("DeathMsg")
}
//----------------------------------------------------------------------------------------------
public reset_hud(id)
{
	if (hs_mode)
		set_user_health(id,1124)

	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public new_round()
{
	hs_mode = (get_cvar_num("hs_mode")) ? true : false
	if ( (hs_mode!=last_mode)&&!hs_mode )
	{
		new players[32],num
		get_players(players,num,"a")
		for (new i=0; i<num; i++)
			set_user_health(players[i],100)
	}
	last_mode = hs_mode

	if (hs_mode)
	{
		new hitzones=0
		hs_head = get_cvar_float("hs_head")
		hs_chest = get_cvar_float("hs_chest")
		hs_stomach = get_cvar_float("hs_stomach")
		hs_larm = get_cvar_float("hs_larm")
		hs_rarm = get_cvar_float("hs_rarm")
		hs_lleg = get_cvar_float("hs_lleg")
		hs_rleg = get_cvar_float("hs_rleg")
		if (hs_head!=0) hitzones += 2
		if (hs_chest!=0) hitzones += 4
		if (hs_stomach!=0) hitzones += 8
		if (hs_larm!=0) hitzones += 16
		if (hs_rarm!=0) hitzones += 32
		if (hs_lleg!=0) hitzones += 64
		if (hs_rleg!=0) hitzones += 128
		set_user_hitzones(0,0,hitzones)
	}
	else
		set_user_hitzones(0,0,255)

	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public damage_event(id)
{
	if (!hs_mode) return PLUGIN_CONTINUE

	new weapon,bodypart
	new attacker = get_user_attacker(id,weapon,bodypart)

	new Float:Modificator
	switch (bodypart)
	{
		case 0: Modificator = 1.0
		case 1: Modificator = hs_head
		case 2: Modificator = hs_chest
		case 3: Modificator = hs_stomach
		case 4: Modificator = hs_larm
		case 5: Modificator = hs_rarm
		case 6: Modificator = hs_lleg
		case 7: Modificator = hs_rleg
	}

	new newHP = get_user_health(id)-floatround( (Modificator-1)*read_data(2) )
	if (newHP-1024>0)
		set_user_health(id,newHP)
	else
	{
		new weaponname[24],headshot
		if (weapon==CSW_HEGRENADE) copy(weaponname[7],23,"grenade")
		else if (weapon==0) copy(weaponname[7],23,"world")
		else get_weaponname(weapon,weaponname,23)
		if (bodypart==1) headshot = 1
		else headshot = 0

		if (id==attacker || attacker==0) // selfkill or killed by world
		{
			set_user_frags(attacker,get_user_frags(attacker)-1)
		}
		else if (get_user_team(id)!=get_user_team(attacker)) // normal kill
		{
			new money = get_user_money(attacker)+300
			if (money>16000) money = 16000
			set_user_money(attacker,money,1)
			set_user_frags(attacker,get_user_frags(attacker)+1)
		}
		else // teamkill
		{
			new money = get_user_money(attacker)-3300
			if (money<0) money = 0
			set_user_money(attacker,money,1)
			set_user_frags(attacker,get_user_frags(attacker)-1)
		}

		MessageBlock(gmsgDeathMsg,BLOCK_ONCE)
		user_kill(id,1)
		message_begin(MSG_ALL,gmsgDeathMsg,{0,0,0},0)
		write_byte(attacker)
		write_byte(id)
		write_byte(headshot)
		write_string(weaponname[7])
		message_end()
	}

	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public set_team(id)
{
	if (hs_mode)
		friend[id] = read_data(2)

	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public hide_status(id)
{
	if (!hs_mode) return PLUGIN_CONTINUE

	set_hudmessage(0,0,0,0.0,0.0,0, 0.0, 0.01, 0.0, 0.0, 4)
	show_hudmessage(id,"")

	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public show_status(id)
{
	if (!hs_mode) return PLUGIN_CONTINUE

	new name[32],color1,color2,pid = read_data(2)
	get_user_name(pid,name,31)
	if (get_user_team(id)==1)
	{
		color1 = 255
		color2 = 0
	}
	else
	{
		color1 = 0
		color2 = 255
	}
	if (friend[id]==1) /* friend */
	{
		set_hudmessage(color1,0,color2,-1.0,0.60,0, 0.01, 3.0, 0.01, 0.01, 4)
		show_hudmessage(id,"Friend: %s   Health: %d%",name,get_user_health(pid)-1024)
	}
	else /* enemy */
	{
		set_hudmessage(color2,0,color1,-1.0,0.60,0, 0.01, 3.0, 0.01, 0.01, 4)
		show_hudmessage(id,"Enemy: %s",name)
	}

	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public show_position(id)
{
	if (!hs_mode) return PLUGIN_CONTINUE

	if (specmode[id])
	{
		new name[32]
		new target = read_data(2)
		get_user_name(target,name,31)
		set_hudmessage(255,255,255,-1.0,0.9,0, 0.01, 5.0, 0.01, 0.01, 4)
		show_hudmessage(id,"%s (%d Health)",name,get_user_health(target)-1024)
	}

	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public set_specmode(id)
{
	if (!hs_mode) return PLUGIN_CONTINUE

	new arg[12]
	read_data(2,arg,11)
	specmode[id] = (arg[10]=='2') ? true : false

	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public client_connect(id)
	specmode[id] = false
//----------------------------------------------------------------------------------------------
