/* AMX Mod script.
*
* (c) Copyright 2003, Leichenklaus 
* This file is provided as is (no warranties). 
*
*
* Stats plugin for knifekills
* Knifekills will be saved using steamid 
* Leader is called Messer-Jocke (known from the movie "Pippi in the South Seas")
* say "/knife" shows current Messer-Jocke 
* Knifekill made by Messer-Jocke will play the Messer-Jocke-Sound
* Other players will get the well known "humiliation"
* The list runs from monday 12.00 AM to sunday 11.59 PM but at least until the current map ends
* The the list will be deleted and a new round will be started
* Of course TKs do not count 
* Partial based on Knifekill Announcer by JustinHoMi
*
*/

#include <amxmod>
#include <amxmisc>

#define MESSAGES   4

new messages[MESSAGES][] = {                             /* random hud messages which announce default knifekills */
"%s sliced and diced %s", 
"%s pulled out knife and gutted %s", 
"%s sneaks carefully behind and knifed %s", 
"%s knived %s"} 

#define MAX_USERS 100                                    /* Maximum count which will be saved in the list (100 should be enough for 1 week) */

new nick[MAX_USERS][33]
new steamid[MAX_USERS][18]
new kills[MAX_USERS][4]
new save_data_file[64]
new maxknife = 0
new minplayers = 3
new file_jocke[64]

public plugin_init() {
   register_plugin("Messer Jocke","0.8","Leichenklaus")
   register_cvar("jocke_delete","1")
   register_cvar("Messer-Jocke", "")
   register_event("DeathMsg","messerjocke","a","4&kni")
   register_clcmd("say /knife","Jocke_zeigen",0,"- shows the current Messer Jocke")
   build_path( save_data_file , 63 , "$basedir/messerjocke.txt" ) /* file where nicks, steamids and knifekills will be saved */
   build_path( file_jocke , 63 , "$basedir/jocke.txt" )           /* file where the index number of the leader will be saved */
   LoadMesserJocke(save_data_file)
   return PLUGIN_CONTINUE
}

public Jocke_zeigen (){
  new who_jocke = get_cvar_num("Messer-Jocke")
  new who_jockeString[3]
  get_cvar_string("Messer-Jocke",who_jockeString,3)
  set_hudmessage(255, 200, 0, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)
  if (equal(who_jockeString,"")){
    show_hudmessage(0,"There is no MESSERJOCKE yet")
  }
  else{
    show_hudmessage(0,"%s is the MESSERJOCKE with %s KNIFEKILL%s so far",nick[who_jocke], kills[who_jocke],(equal(kills[who_jocke],"1"))?"":"S" )
  }
  return PLUGIN_CONTINUE
}
  

public LoadMesserJocke (file_name[]){
  new today[8]
  new line_text[64]
  new a, pos = 0
  get_time("%a",today,8)
  if (get_cvar_num("jocke_delete")){
    if (!equal(today,"Mon")){
      set_cvar_num("jocke_delete",0)
    }
  }
  else{
    if (equal(today,"Mon")){                                         /* Day the list will be reset (default monday) */
      set_cvar_num("jocke_delete", 1)
      set_cvar_string("Messer-Jocke", "")
      if (file_exists(file_name)){
        new file_old[64]
        if (file_exists(file_jocke)){ 
          delete_file (file_jocke)
        }
        build_path( file_old , 63 , "$basedir/messerjockeOLD.txt" )  /* File where the old list will be saved before starting a new one */
        if (file_exists(file_old)){ 
          delete_file (file_old)
        }
        while (read_file(file_name, pos, line_text, 63, a)){
          write_file (file_old, line_text, pos)
          pos++ 
        }
        delete_file (file_name)
      }
    }
  }
  
  if (file_exists(file_jocke)){
    pos = 0
    read_file(file_jocke, pos, line_text, 63, a) 
    set_cvar_string("Messer-Jocke", line_text)
  }
  if (file_exists(file_name)){
    pos = 0
    while (read_file(file_name, pos, line_text, 63, a)){
      parse(line_text,nick[pos],32, steamid[pos], 17, kills[pos], 3)
      pos++ 
    }
    maxknife = pos 
  }
  return PLUGIN_CONTINUE
}

public SaveMesserJocke (){
  
  new text[64], b = 0
  new who_jockeString[3]
  get_cvar_string("Messer-Jocke",who_jockeString,3)
  write_file (file_jocke, who_jockeString, b)
  while (b < maxknife){
    format (text, 63,"^"%-32s^" %-17s %s", nick[b],steamid[b],kills[b])
    write_file (save_data_file, text, b)
    b++
    } 
  return PLUGIN_CONTINUE
}

public plugin_end(){                      /* At mapchange or server shutdown the list will be saved in a file */
  SaveMesserJocke()
  }

public messerjocke(id){

   new killer = read_data(1);
   new victim = read_data(2);
   
   new killer_name[33], victim_name[33], killer_steamid[18]
   new bool:enemykill = (get_user_team(killer) != get_user_team(victim))
   get_user_name(killer,killer_name,32)
   get_user_authid(killer,killer_steamid,17)
   get_user_name(victim,victim_name,32)
   new j = 0, array_pos = -1, found_flag = 0, jocke = -1, killnum = 0
   if (!enemykill) return PLUGIN_CONTINUE                                  /* TKs don't count */
   if (get_playersnum() > minplayers){                                     /* if more players than minplayers then the kill counts for Messer-Jocke */
     while (j <= maxknife){
       if (equal(killer_steamid, steamid[j])){
         array_pos = j
         found_flag = 1
         killnum = strtonum(kills[j])
         killnum++
         numtostr(killnum, kills[j], 3)
         nick[j] = killer_name
       }
       j++
     }
     if ((found_flag == 0) && (maxknife < MAX_USERS)){   
       steamid[maxknife] = killer_steamid
       nick[maxknife] = killer_name
       kills[maxknife] = "1"
       if (maxknife == 0){
         jocke = maxknife
       }
       maxknife++
     }
     else{
       new i = 0
       jocke = array_pos
       while (i <= maxknife){
         if (strtonum(kills[array_pos]) <= strtonum(kills[i])){
           if (i != array_pos){
             jocke = -1
             break
           }	 
         }
         i++
       }     
     }
     if (jocke > -1){                               
       set_cvar_num("Messer-Jocke",jocke)
       set_hudmessage(0, 255, 0, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)
       show_hudmessage(0,"%s is the MESSERJOCKE with %s KNIFEKILL%s so far",nick[jocke], kills[jocke],(equal(kills[jocke],"1"))?"":"S" )
       client_cmd(0,"spk misc/messerjocke.wav")     /* If the leader on the list made a knifing the Messer-Jocke sound is played */
       return PLUGIN_HANDLED
     }
   }
   set_hudmessage(200, 100, 0, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)
   show_hudmessage(0,messages[ random_num(0,MESSAGES-1) ],killer_name, victim_name)
   client_cmd(0,"spk misc/humiliation.wav")       /* knifing by another player....normal sound */
   return PLUGIN_CONTINUE
}


public plugin_precache()
{
        
	precache_sound("misc/humiliation.wav") /* normal knifekill sound */
	precache_sound("misc/messerjocke.wav") /* Messer-Jocke sound */
	return PLUGIN_CONTINUE
}
