/* AMX Mod script. 
*
* This file is provided as is (no warranties). 
*
* This plugin contains:
* o multikill announcement
* o bomb events
* o killing streak
* o enemy remaining
* o round counter
* o italy bonus kill
* o knife kill
* o headshot kill
* o greanade kill
* o last man
* o double kill
* o player name
* o first blood sound
*
* To use with AMX 0.9.9 (and higher) and Counter-Strike.
* Stats can be enabled with amx_statscfg and amx_statscfgmenu commands.
* NOTE: For permanent disable, comment file from plugins.ini
* or use amx_pausecfg and amx_pausecfgmenu commands.
* Rest of stats can be found in csstats plugin.
*
*
* KWo - Added new features - 
*     - Bomb Cound Down HUD, 
*     - delaying or disabling show some HUD messages using 3 and 4 channnel for 
*       "just killed" players, to prevent overwrite their attackers and vitims list,
*     - added killingspree HUD messages from some old Ditka's plugin,
*     - added info how many seconds before explosion the bomb has been defused.
* To do - need make the language support (and translations) for killingspree HUD messages.
*/

#include <translator>
#include <amxmod> 

public MultiKill
public MultiKillSound
public BombPlanting
public BombDefusing
public BombPlanted
public BombDefused
public BombFailed
public BombPickUp
public BombDrop
public BombCountVoice
public BombCountHUD // hud displaying bomb count down timer
public BombCountDef
public BombReached
public ItalyBonusKill
public EnemyRemaining
public LastMan
public KnifeKill
public KnifeKillSound
public GrenadeKill
public GrenadeSuicide
public HeadShotKill
public HeadShotKillSound
public RoundCounterSound
public RoundCounter
public KillingStreak
public KillingStreakChat
public KillingStreakSound
public KillingStreakReset
public DoubleKill
public DoubleKillSound
public PlayerName
public FirstBloodSound

//added from Kilstreak plugin
public KillingStreakHUD // normal hud display on of (hs nade knice) etc
public KillingStreakHUDEnd // announce streak end to all 
public KillingStreakSay // the say /streak enabling system

new g_disabledMsg[] = "Server has disabled that option"

new g_kills[33] = {0,...} 
new g_deaths[33] = {0,...} 
new g_knife[33] = {0,...} 
new g_hs[33] = {0,...} 
new g_nade[33] = {0,...} 
new longestkillstreak[33] = {0,...} 
new longestdeathstreak[33] = {0,...} 
//end added by killstreak plugin

new g_multiKills[33][2]
new g_C4Timer 
new g_Defusing 
new g_Planter 
new g_Defuser 
new Float:g_LastOmg 
new g_C4TimerDef // the c4 stop time 
new Float:g_LastPlan 
new g_LastAnnounce
new g_roundCount
new Float:g_doubleKill
new g_doubleKillId
new g_friend[33] 
new g_firstBlood
new g_justKilled[33]

new g_MultiKillMsg[7][] = { 
  "Multi-Kill! %s^nwith %d kills (%d hs)", 
  "Ultra-Kill!!! %s^nwith %d kills (%d hs)", 
  "%s IS ON A KILLING SPREE!!!^nwith %d kills (%d hs)",  
  "RAMPAGE!!! %s^nwith %d kills (%d hs)" ,
  "%s IS UNSTOPPABLE!!!^nwith %d kills (%d hs)" ,
  "%s IS A MONSTER!^nwith %d kills (%d hs)",
  "%s IS GODLIKE!!!!^nwith %d kills (%d hs)"
}
new g_Sounds[7][] = { 
  "multikill", 
  "ultrakill", 
  "killingspree", 
  "rampage",    
  "unstoppable",   
  "monsterkill",
  "godlike"  
}
new g_KillingMsg[7][] = {
  "%s: Multi-Kill!",
  "%s: Ultra-Kill!!!",
  "%s IS ON A KILLING SPREE!!!",
  "%s: RAMPAGE!!!",  
  "%s IS UNSTOPPABLE!!!",  
  "%s IS A MONSTER!",
  "%s IS GODLIKE!!!"
}
new g_KinfeMsg[4][] = { 
  "%s sliced and diced %s", 
  "%s pulled out knife and gutted %s", 
  "%s sneaks carefully behind and knifed %s", 
  "%s knived %s"
}
new g_LastMessages[4][] = { 
  "Now all depend on you!", 
  "I hope you still have a healthpack.", 
  "All your teammates were killed. Good luck!", 
  "Now you are alone. Have fun!" 
} 
new g_HeMessages[4][] = { 
  "%s sends a little gift to %s",   
  "%s throws a small present to %s",   
  "%s made a precision throw to %s",   
  "%s got a big explosion for %s"
}
new g_SHeMessages[4][] = { 
  "%s detonated himself with a grenade",   
  "%s trys the effect of a HE Grenade",   
  "%s kicked a grenade into his own ass",   
  "%s explodes!"
}
new g_HeadShots[7][] = { 
  "$kn killed $vn with a well^nplaced shot to the head!",   
  "$kn removed $vn's^nhead with the $wn",   
  "$kn turned $vn's head^ninto pudding with the $wn",   
  "$vn got pwned by $kn",
  "$vn's head has been^nturned into red jello",
  "$kn has superb aim with the $wn,^nas $vn well knows.",
  "$vn's head stayed in $kn's^ncrosshairs a bit too long..."
}

new g_teamsNames[4][] = {
  "TERRORIST",
  "CT",
  "TERRORISTS",
  "CTS"
}

public plugin_init(){
  load_translations("miscstats2")
  register_plugin(_T("Misc. Stats 2"),"0.9.9b","default + KWo") 
  register_event("DeathMsg","eDeathMsg","a")
  register_event("TextMsg","eRestart","a","2&#Game_C","2&#Game_w")
  register_event("SendAudio", "eEndRound", "a", "2&%!MRAD_terwin","2&%!MRAD_ctwin","2&%!MRAD_rounddraw") 
  register_event("RoundTime", "eNewRound", "bc") 
  register_event("StatusValue","setTeam","be","1=1") 
  register_event("StatusValue","showStatus","be","1=2","2!0")
  register_event("StatusValue","hideStatus","be","1=1","2=0")  
  register_event("ResetHUD", "reset_hud", "b")
  new mapname[32]
  get_mapname(mapname,31)
  if (equali(mapname,"de_",3)||equali(mapname,"csde_",5)){
    register_event("StatusIcon", "eGotBomb", "be", "1=1", "1=2", "2=c4") 
    register_event("SendAudio", "eBombPlanted", "a", "2&%!MRAD_BOMBPL") 
    register_event("SendAudio", "eBombDef", "a", "2&%!MRAD_BOMBDEF") 
    register_event("TextMsg", "eBombFail", "a", "2&#Target_B") 
    register_event("BarTime", "eBombDefG", "be", "1=10", "1=5","1=3") 
    register_event("BarTime", "eBombDefL", "be", "1=0") 
    register_event("TextMsg", "eBombPickUp", "bc", "2&#Game_bomb_p") 
    register_event("TextMsg", "eBombDrop", "bc", "2&#Game_bomb_d") 
  }
  else if ( equali( mapname ,  "cs_italy"  ) ) { 
    register_event( "23" , "chickenKill", "a" , "1=108" , /*"12=106",*/ "15=4" ) 
    register_event( "23" , "radioKill", "a" , "1=108" , /*"12=294",*/ "15=2" ) 
  }
}

public plugin_cfg(){
  new g_addStast[] = "amx_statscfg add ^"%s^" %s"
  server_cmd(g_addStast,"MultiKill","MultiKill") 
  server_cmd(g_addStast,"MultiKillSound","MultiKillSound") 
  server_cmd(g_addStast,"Bomb Planting","BombPlanting")
  server_cmd(g_addStast,"Bomb Defusing","BombDefusing")  
  server_cmd(g_addStast,"Bomb Planted","BombPlanted")  
  server_cmd(g_addStast,"Bomb Defuse Succ.","BombDefused")
  server_cmd(g_addStast,"Bomb Def. Failure","BombFailed")  
  server_cmd(g_addStast,"Bomb PickUp","BombPickUp") 
  server_cmd(g_addStast,"Bomb Drop","BombDrop")
  server_cmd(g_addStast,"Bomb Count Down","BombCountVoice") 
  server_cmd(g_addStast,"Bomb Count Down HUD","BombCountHUD") 
  server_cmd(g_addStast,"Bomb Count Down (def)","BombCountDef")  
  server_cmd(g_addStast,"Bomb Site Reached","BombReached")
  server_cmd(g_addStast,"Italy Bonus Kill","ItalyBonusKill")  
  server_cmd(g_addStast,"Last Man","LastMan")
  server_cmd(g_addStast,"Knife Kill","KnifeKill")  
  server_cmd(g_addStast,"Knife Kill Sound","KnifeKillSound")    
  server_cmd(g_addStast,"Grenade Kill","GrenadeKill")
  server_cmd(g_addStast,"Grenade Suicide","GrenadeSuicide")
  server_cmd(g_addStast,"HeadShot Kill","HeadShotKill")  
  server_cmd(g_addStast,"HeadShot Kill Sound","HeadShotKillSound")
  server_cmd(g_addStast,"Round Counter","RoundCounter")
  server_cmd(g_addStast,"Round Counter Sound","RoundCounterSound")
  server_cmd(g_addStast,"Killing Streak","KillingStreak")
  server_cmd(g_addStast,"Killing Streak Chat","KillingStreakChat")    
  server_cmd(g_addStast,"Killing Streak Sound","KillingStreakSound") 
  server_cmd(g_addStast,"Killing Streak Reset","KillingStreakReset")       
  server_cmd(g_addStast,"Enemy Remaining","EnemyRemaining")  
  server_cmd(g_addStast,"Double Kill","DoubleKill")    
  server_cmd(g_addStast,"Double Kill Sound","DoubleKillSound") 
  server_cmd(g_addStast,"Player Name","PlayerName")   
  server_cmd(g_addStast,"First Blood Sound","FirstBloodSound") 
  server_cmd(g_addStast,"Killing Streak HUD","KillingStreakHUD") 
  server_cmd(g_addStast,"Killing Streak End","KillingStreakHUDEnd") 
  server_cmd(g_addStast,"Killing Streak Say /streak","KillingStreakSay")     
}

public eDeathMsg(){
  new killer = read_data(1)
  if ( killer == 0 ) return
  new victim = read_data(2) 

  new param3[1]
  param3[0]=victim
  g_justKilled[victim]=1
  set_task(10.0,"free_chan",5678+victim, param3, 1)        
  
  new bool:enemykill = (get_user_team(killer) != get_user_team(victim))
  new bool:TK = ( ( get_user_team(killer) == get_user_team(victim) )  && (killer!=victim) )
  new headshot = read_data(3)
//  new selfkill = ( killer == victim ) ? 1:0

  new killer_name[32], victim_name[32] 
  get_user_name(killer,killer_name,31) 
  get_user_name(victim,victim_name,31) 
  new dm_ppl[32], plnum = 0
  get_players(dm_ppl,plnum) 

// KillstreakHUD begining
  if(KillingStreakHUD){
    new param[8]
    param[0]=victim
    param[1]=g_kills[victim]
    param[2]=g_hs[victim]
    param[3]=g_nade[victim]
    param[4]=g_knife[victim]
    param[5]=longestkillstreak[victim]
    param[6]=longestdeathstreak[victim]
    param[7]=1
    set_task(12.0,"showstr_al",victim+3677,param,8)
  }
  if ((g_kills[victim] > 4) && KillingStreakHUDEnd) { 
    new param[6]
    param[0]=victim
    param[1]=killer
    param[2]=g_kills[victim]
    param[3]=g_hs[victim]
    param[4]=g_nade[victim]
    param[5]=g_knife[victim]		
    set_task(12.0,"showstr_end_by",victim+3678,param,6)		
  } 
  if ( headshot && !TK ) { 
    g_hs[killer] ++ 
  } 
  new arg[4] 
  read_data( 4 , arg , 3  )  
  if ( equal( arg, "kni" ) && enemykill )  { 
    g_knife[killer] ++ 
  } 
  else if ( equal( arg, "gre" ) && enemykill )  { 
    g_nade[killer] ++  
  } 

  if (enemykill) {
    g_kills[killer] += 1 
    g_deaths[killer] = 0   
  }
  else g_kills[killer] -= 1 
  
  g_kills[victim] = 0 
  g_deaths[victim] += 1 
  g_hs[victim] = 0
  g_knife[victim] = 0
  g_nade[victim] = 0
  if (g_kills[killer] > longestkillstreak[killer]) { 
    longestkillstreak[killer] = g_kills[killer]
  } 
  if (g_deaths[victim] > longestdeathstreak[victim]) { 
    longestdeathstreak[victim] = g_deaths[victim]  
  } 
// KillstreakHUD part end

//normal miscstats     
  if ( g_firstBlood ) {
  	g_firstBlood = 0
  	if ( FirstBloodSound ) play_sound("misc/firstblood")
  }
  if ( (KillingStreak || KillingStreakSound || KillingStreakHUD || KillingStreakSound) ) {    
    new a = g_kills[ killer ] - 3
    if ( (a > -1) && !( a % 2 ) ) {
      new param2[2]
      param2[0]=killer
      param2[1]=a
      set_task(7.0,"showkillspree",3500+killer, param2,2)
    }
  }
  if ( MultiKill || MultiKillSound ) {
    if (killer) { 
      if (enemykill) { 
        g_multiKills[killer][0]++ 
        g_multiKills[killer][1] += headshot
      }
      else g_multiKills[killer][0]--
      g_multiKills[victim][0]=0
      g_multiKills[victim][1]=0
      new param[2]
      param[0] = killer 
      param[1] = g_multiKills[killer][0] 
      set_task( 4.0 + float( param[1] ) ,"checkKills",678+killer,param,2)
    }    
  }
  if ( EnemyRemaining ) {
    new ppl[32], pplnum = 0
    new team = get_user_team( victim ) - 1
    if ( team >= 0 && team < 4 )
      get_players(ppl,pplnum,"e", g_teamsNames[1 - team] ) 
    if (pplnum){
      new eppl[32], epplnum 
      get_players(eppl,epplnum,"ae",g_teamsNames[team]) 
      if (epplnum) { 
        new message[128],team_name[32]
        for(new a=0; a<pplnum; ++a) {
          if (!g_justKilled[ppl[a]]) {        
            set_hudmessage(255,255,255,0.02,0.85,2, 0.05, 0.1, 0.02, 3.0, 3) 
            format(team_name,31,"%s",(epplnum==1)?g_teamsNames[team]:g_teamsNames[team+2])          	
            format(message,127,_T("%d %s Remaining...",ppl[a]),epplnum,_T(team_name,ppl[a]))
            show_hudmessage(ppl[a],message)
          }
        }
      }  
    }
  }
  if ( LastMan ) {
    new cts[32], ts[32], ctsnum, tsnum 
    get_players(cts,ctsnum,"ae", g_teamsNames[1] )    
    get_players(ts,tsnum,"ae", g_teamsNames[0] ) 
    if ( ctsnum == 1 && tsnum == 1 ){ 
      new ctname[32], tname[32] 
      get_user_name(cts[0],ctname,31) 
      get_user_name(ts[0],tname,31)
      for(new a=0; a<plnum; ++a) {
        if (!g_justKilled[dm_ppl[a]]) {  
          set_hudmessage(0, 255, 255, -1.0, 0.35, 0, 6.0, 6.0, 0.5, 0.15, 3)        
          show_hudmessage(dm_ppl[a],_T("%s vs. %s"),ctname,tname) 
        }
      }
      play_sound("misc/maytheforce") 
    }
    else if ( !g_LastAnnounce  ) {
      new oposite = 0, team = 0
      if ( ctsnum == 1 && tsnum > 1 ) {
        g_LastAnnounce = cts[0] 
        oposite = tsnum
        team = 0
      }
      else if ( tsnum == 1 && ctsnum > 1 ) {
        g_LastAnnounce = ts[0]
        oposite = ctsnum
        team = 1
      }
      if (g_LastAnnounce){ 
        new name[32] 
        new teammsg[64]
        get_user_name(g_LastAnnounce,name,31) 
        new lastan = random_num(0,3)
        for(new a=0; a<plnum; ++a) {
          if (!g_justKilled[dm_ppl[a]]) {          
            set_hudmessage(0, 255, 255, -1.0, 0.35, 0, 6.0, 6.0, 0.5, 0.15, 3)
            format(teammsg,63,"%s%s",g_teamsNames[team],(oposite==1)?"":"S")
            show_hudmessage(dm_ppl[a],"%s (%d HP) vs. %d %s : %s", name,             
            get_user_health(g_LastAnnounce),
            oposite,
            _T(teammsg),
            _T(g_LastMessages[ lastan ]) )
          }
        }
        if (!is_user_connecting(g_LastAnnounce))
	        client_cmd(g_LastAnnounce,"spk misc/oneandonly") 
      }
    }
  }
  if ( equal( arg, "kni" ) && ( KnifeKill || KnifeKillSound )  )  {
    if ( KnifeKill ) {
      set_hudmessage(255, 100, 100, -1.0, 0.25, 1, 6.0, 6.0, 0.5, 0.15, 1)  
      show_hudmessage(0,_T(g_KinfeMsg[ random_num(0,3) ]),killer_name,victim_name) 
    }
    if ( KnifeKillSound ) play_sound("misc/humiliation") 
  }
  else if ( equal( arg, "gre" ) && (GrenadeKill || GrenadeSuicide)  )  {
    set_hudmessage(255, 100, 100, -1.0, 0.25, 1, 6.0, 6.0, 0.5, 0.15, 1)    
    if ( killer != victim ){
      if ( GrenadeKill ) show_hudmessage(0,_T(g_HeMessages[ random_num(0,3)]),killer_name,victim_name) 
    }
    else if ( GrenadeSuicide ) show_hudmessage(0,_T(g_SHeMessages[ random_num(0,3) ]),victim_name) 
  }
  if ( headshot && (HeadShotKill || HeadShotKillSound) )  {
    if ( HeadShotKill ){
      new weapon_name[32], message[128], i, p[32], pnum
      read_data( 4 , weapon_name , 31  )

      get_players(p,pnum,"c")
      new hsm = random_num(0,6)
      for(i=0;i<pnum;i++) {
        copy( message, 127, _T(g_HeadShots[ hsm ], p[i]) )
        replace( message, 127 , "$vn", victim_name )
        replace( message, 127 , "$wn", weapon_name )
        replace( message, 127 , "$kn", killer_name )
        set_hudmessage(100, 100, 255, -1.0, 0.15, 0, 6.0, 6.0, 0.5, 0.15, 1)    
        show_hudmessage(p[i],message ) 
      }
    }
    if ( HeadShotKillSound ) {
    	client_cmd(killer,"spk misc/headshot") 
    	client_cmd(victim,"spk misc/headshot")
   	}
  }
  if ( DoubleKill || DoubleKillSound ) {
    new Float:nowtime = get_gametime()
    if ( g_doubleKill == nowtime && g_doubleKillId == killer ) {
      if ( DoubleKill ) {
        new name[32]
        get_user_name( killer , name , 31  )
        for(new a=0; a<plnum; ++a) {
          if (!g_justKilled[dm_ppl[a]]) {          
            set_hudmessage(255, 0, 255, -1.0, 0.15, 0, 6.0, 6.0, 0.5, 0.15, 3)
            show_hudmessage(dm_ppl[a],_T("Wow! %s made a double kill!!!") ,name )
          }
        }
      }
      if ( DoubleKillSound ) play_sound("misc/doublekill")
    }
    g_doubleKill = nowtime
    g_doubleKillId = killer
  }
} 

public hideStatus(id) {
  if ( PlayerName ){
    set_hudmessage(0,0,0,0.0,0.0,0, 0.0, 0.01, 0.0, 0.0, 4) 
    show_hudmessage(id,"")
  }
}

public setTeam(id) { 
  g_friend[id] = read_data(2)
}

public showStatus(id) {
  if ( PlayerName ){
    new name[32],pid = read_data(2) 
    get_user_name(pid,name,31)
    new color1 = 0,color2 = 0
    if ( get_user_team(pid)==1 )
      color1 = 255
    else
      color2 = 255
    if (g_friend[id]==1){ // friend
      new clip, ammo, wpnid = get_user_weapon(pid,clip,ammo) 
      new wpnname[32] 
      get_weaponname(wpnid,wpnname,31) 
      set_hudmessage(color1,50,color2,-1.0,0.60,1, 0.01, 3.0, 0.01, 0.01, 4)
      show_hudmessage(id,_T("%s -- %d HP / %d AP / %s"),name, 
        get_user_health(pid),get_user_armor(pid),wpnname[7])
    } 
    else { 
      set_hudmessage(color1,50,color2,-1.0,0.60,1, 0.01, 3.0, 0.01, 0.01, 4)
      show_hudmessage(id,name) 
    } 
  }
}

public eNewRound() {
  if ( read_data(1) == floatround(get_cvar_float("mp_roundtime") * 60.0) ) {
    g_firstBlood = 1
    g_C4Timer = 0
    ++g_roundCount
    if ( RoundCounter ) {
      set_hudmessage(220, 50, 0, -1.0, 0.1, 0, 6.0, 6.0, 0.5, 0.15, 1) 
      show_hudmessage(0,  _T("Prepare to FIGHT!^nRound %d") ,  g_roundCount )
    }
    if ( RoundCounterSound )  play_sound("misc/prepare" )
    if ( KillingStreakChat  ) {
      new appl[32],ppl, i
      get_players(appl,ppl, "a" )
      for(new a = 0; a < ppl; ++a) {
        i = appl[ a ]
        if ( g_kills[ i ] >= 2 )
          client_print( i , print_chat , _T("* You've killed %d in a row so far"), g_kills[ i ] )
        else if (  g_deaths[ i ] >= 2 )
          client_print( i , print_chat , _T("* Careful! You've died %d rounds in a row now..."), g_deaths[ i ] )     
      }
    }
  }
}

public eRestart() {
  eEndRound()
  g_roundCount = 0
  g_firstBlood = 1
  for (new pl = 1; pl < 32; ++pl) g_justKilled[pl] = 0  
  if(KillingStreakReset){
  	for(new a = 0; a < 33; ++a)  g_kills[ a ] = g_deaths[ a ] = 0          
  }
}

public eEndRound(){
  g_C4Timer = -2
//  g_LastPlan = 0.0 
  g_LastOmg = 0.0
  remove_task(8038)
  g_LastAnnounce = 0
}

public checkKills(param[]){ 
  new kid = param[0]
  new a = param[1]
  new ck_ppl[32], plnum=0
  get_players(ck_ppl,plnum)  
  if (a == g_multiKills[kid][0]){
    if ( a > 2 ) {
      a -= 3 
      if ( a > -1 ){
        if ( MultiKill || MultiKillSound ) {
          if (a > 6) a=6
          new name[32]
          get_user_name(kid,name,31)
          if ( MultiKill ){
            if (a > 6 ) a = 6
            for(new i=0; i<plnum; ++i) {
              if (!g_justKilled[ck_ppl[i]]) {  
                set_hudmessage(255, 0, 100, 0.05, 0.47, 2, 0.02, 6.0, 0.01, 0.1, 3)
                show_hudmessage(ck_ppl[i],_T(g_MultiKillMsg[a]),name,g_multiKills[kid][0],g_multiKills[kid][1]) 
              }
            }
          }
          if ( MultiKillSound ) {
      	    new sound[24]
	    format(sound, 23, "misc/%s", g_Sounds[a])
	    play_sound(sound)
          }          
          g_multiKills[kid] = { 0,0 }
        }            	
      }
    }    
  }
}

public chickenKill() {
  if ( ItalyBonusKill ) announceEvent( 0 , "Somebody killed a chicken!!!"  )
}

public radioKill() {
  if ( ItalyBonusKill ) announceEvent( 0 , "Somebody blew up the radio!!!" )
}


announceEvent( id , message[] ){
  new name[32]
  get_user_name(id, name , 31) 
  set_hudmessage(255, 100, 50, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 2)
  show_hudmessage(0,_T(message),name)
}

announceEvent2( id, message[]) {
  new name[32]
  new c4_left = g_C4TimerDef
  get_user_name(id, name , 31)
  set_hudmessage(255, 100, 50, -1.0, 0.28, 0, 6.0, 6.0, 0.5, 0.15, 2)
  show_hudmessage(0,_T(message),name,c4_left)
}

public eGotBomb(id){ 
  g_Planter = id 
  g_Defuser = g_Defusing = 0 
  if ( BombReached && read_data(1)==2 && g_LastOmg<get_gametime()){ 
    g_LastOmg = get_gametime() + 15.0
    announceEvent(g_Planter ,   "Omg! %s reached the target!" )
  } 
} 

public eBombDefG(id){ 
  if (read_data(1) == 3){
    if ( BombPlanting && g_LastPlan<get_gametime() ){ 
      g_LastPlan = get_gametime() + 15.0
      announceEvent(g_Planter ,   "%s is planting the bomb!" )
    } 
  } 
  else { 
    g_Defuser = g_Defusing = id 
    if ( BombDefusing && g_LastPlan<get_gametime()){ 
      g_LastPlan = get_gametime() + 15.0
      announceEvent(g_Defusing ,   "%s is defusing the bomb..." )
    } 
  } 
} 

public eBombDefL(id) { 
  g_Defusing = 0
}

public eBombPlanted() { 
  if ( g_C4Timer != -2 ){
    if (BombPlanted) announceEvent(g_Planter ,   "%s set us up the bomb!!!" )
    g_C4Timer = get_cvar_num("mp_c4timer")
    set_task(1.0,"bombTimer",8038,"",0,"b") 
    g_LastPlan = 0.0
  }
}
public bombTimer(){ 
  if (--g_C4Timer > 0){ 
    if (BombCountVoice) { 
      if (g_C4Timer == 40 || g_C4Timer == 30 || g_C4Timer == 20){ 
        new temp[48] 
        num_to_word(g_C4Timer,temp,47)
        format(temp, 63, "^"vox/%s seconds until explosion^"", temp)
	play_sound(temp)
      } 
      else if (g_C4Timer < 11){ 
        new temp[48] 
        num_to_word(g_C4Timer,temp,47) 
        format(temp, 63, "^"vox/%s^"", temp)
	play_sound(temp)
      } 
    }
    new bt_ppl[32], plnum = 0 
    get_players(bt_ppl,plnum)     
    if (BombCountDef && g_Defusing) client_print(g_Defusing,print_center,"%d",g_C4Timer)
    if (g_Defusing) g_C4TimerDef = g_C4Timer
    if (BombCountHUD){ 
      for (new a=0; a<plnum; a++) {
      	if ( !g_justKilled[bt_ppl[a]] ) {    
          if(g_C4Timer < 7) set_hudmessage(150, 0, 0, -1.0, 0.80, 0, 1.0, 1.0, 0.01, 0.01, 4)
          if(g_C4Timer > 6) set_hudmessage(150, 150, 0, -1.0, 0.80, 0, 1.0, 1.0, 0.01, 0.01, 4)
          if(g_C4Timer > 11) set_hudmessage(0, 150, 0, -1.0, 0.80, 0, 1.0, 1.0, 0.01, 0.01, 4)
          show_hudmessage(bt_ppl[a],"C4: %d",g_C4Timer)
        }
      }  
    }
  } 
  else remove_task(8038)
}

public eBombDef(){ 
   if (BombDefused){   
      	announceEvent2(g_Defuser , "%s defused the bomb!^n C4 Stopped at %d sec")
   }
}
 
public eBombFail(){  
   if (BombFailed && g_Defuser ){    
   	announceEvent(g_Defuser ,  "%s failed to defuse the bomb..." ) 
   }   
} 

public eBombPickUp(id){
  if (BombPickUp) announceEvent(id , "%s pick up the bomb...")
}  

public eBombDrop() {
  if (BombDrop) announceEvent(g_Planter , "%s dropped the bomb!!!")
}

public showmultikill(param2[]) {
  new MID=param2[0]
  new msg_num=param2[1]
  new sm_ppl[32], plnum = 0
  get_players(sm_ppl,plnum)
  new name[32]
  get_user_name( MID , name , 31 )
  if ( MultiKill ){  
    if ( msg_num  > 6 ) msg_num = 6    
    for(new a=0; a<plnum; ++a) {
      if (!g_justKilled[sm_ppl[a]]) {  
        set_hudmessage(255, 0, 100, 0.05, 0.47, 2, 0.02, 6.0, 0.01, 0.1, 3)
        show_hudmessage(sm_ppl[a],_T(g_MultiKillMsg[ msg_num ]), name, g_multiKills[MID][0],g_multiKills[MID][1] )
      }
    }
  }
  if ( MultiKillSound ) {
    new sound[24]
    format(sound, 23, "misc/%s", g_Sounds[msg_num])
    play_sound(sound)
  }
  g_multiKills[MID] = { 0,0 }
}
  
public showkillspree(param2[]){
  new MID=param2[0]
  new msg_num=param2[1]
  new ss_ppl[32], plnum = 0
  get_players(ss_ppl,plnum)  
  new name[32]
  get_user_name( MID , name , 31 )
  if ( (msg_num >>= 1) > 6 ) msg_num = 6
  if ( KillingStreak ){
    for(new a=0; a<plnum; ++a) {
      if (!g_justKilled[ss_ppl[a]]) {    
        set_hudmessage(0, 100, 255, 0.05, 0.50, 2, 0.02, 6.0, 0.01, 0.1, 3)
        show_hudmessage(ss_ppl[a],_T(g_KillingMsg[ msg_num ]), name )       
      }
    }
  }
  if (  KillingStreakSound )  {
    new file[32]
    format(file, 32, "misc/%s", g_Sounds[msg_num])
    play_sound(file)
  }
}

public free_chan(param3[]) {
  new MID=param3[0]
  g_justKilled[MID]=0
}

public play_sound(sound[]) {
  new players[32], pnum
  get_players(players, pnum, "c")
  new i
  for (i=0; i<pnum; i++) {
    if (is_user_connecting(players[i]))
      continue
    client_cmd(players[i], "spk %s", sound)
  }
}

// Killstreak part

public reset_hud(id) { 
  if (g_kills[id] > 0) { 
    if(KillingStreakHUD) {			
      new param[8]
      param[0]=id
      param[1]=g_kills[id]
      param[2]=g_hs[id]
      param[3]=g_nade[id]
      param[4]=g_knife[id]
      param[5]=longestkillstreak[id]
      param[6]=longestdeathstreak[id]
      param[7]=0
      set_task(7.0,"showstr_al",id,param,8)
    } 
  } 
  else { 
    if (KillingStreakHUD) {
      new param[4]
      param[0]=id
      param[1]=g_deaths[id]
      param[2]=longestkillstreak[id]
      param[3]=longestdeathstreak[id]
      set_task(7.0,"showstr_dt",id,param,4)
    }
  } 
  return PLUGIN_CONTINUE 
} 

public disp_streak(id) { 
  if ( !KillingStreakSay ){
    client_print(id,print_chat, g_disabledMsg )
    return PLUGIN_HANDLED
  }
  if (g_kills[id] > 0) { 
    if(KillingStreakHUD) {			
      new param[8]
      param[0]=id
      param[1]=g_kills[id]
      param[2]=g_hs[id]
      param[3]=g_nade[id]
      param[4]=g_knife[id]
      param[5]=longestkillstreak[id]
      param[6]=longestdeathstreak[id]
      param[7]=0
      set_task(1.0,"showstr_al",id,param,8)
    } 
  } 
  else { 
    if (KillingStreakHUD) {
      new param[4]
      param[0]=id
      param[1]=g_deaths[id]
      param[2]=longestkillstreak[id]
      param[3]=longestdeathstreak[id]
      set_task(7.0,"showstr_dt",id,param,4)
    }
  } 
  return PLUGIN_CONTINUE 
} 

public client_putinserver(id) { 
  g_multiKills[id] = { 0 , 0 }
  g_kills[id] = 0
  g_deaths[id] = 0
  g_knife[id] = 0
  g_hs[id] = 0
  g_nade[id] = 0
  longestdeathstreak[id] = 0
  longestkillstreak[id] = 0
  return PLUGIN_CONTINUE 
} 

public showstr_al(param[]){
  new VID = param[0]
  new l_kills=param[1]
  new l_hs=param[2]
  new l_nade=param[3]
  new l_knife=param[4]
  new l_longkstreak=param[5]
  new l_longdstreak=param[6]	 
  new l_end=param[7]	
  set_hudmessage(0,150,0,0.02,0.85,2, 0.05, 0.1, 0.01, 6.0, 4) 
  new sBuffer[255]
  new iLen=0
  if (l_end) iLen=format(sBuffer, 255, "Your latest streak was %d kill",l_kills)
  else iLen=format(sBuffer,255, "Your current streak is %d kill",l_kills)	
  if(l_kills!=1) iLen += format(sBuffer[iLen],255-iLen,"s") //add s letter to change kill to kills if not equal 1
  if(l_hs || l_nade || l_knife) {
    iLen += format(sBuffer[iLen],255-iLen," (")
    if(l_hs)	iLen += format(sBuffer[iLen],255-iLen, "%d hs ",l_hs)
    if(l_nade)	iLen += format(sBuffer[iLen],255-iLen, "%d nade ",l_nade)
    if(l_knife)	iLen += format(sBuffer[iLen],255-iLen, "%d knife ",l_knife)
    iLen += format(sBuffer[iLen],255-iLen,")")
  }
  iLen += format(sBuffer[iLen],255-iLen, "^nYour longest killstreak is %d.  Your longest deathstreak is %d.", l_longkstreak, l_longdstreak)
  show_hudmessage(VID, sBuffer) 	
  return PLUGIN_CONTINUE
}

public showstr_dt(param[]){
  set_hudmessage(150,150,0,0.02,0.85,2, 0.05, 0.1, 0.01, 6.0, 4) 
  new VID=param[0]
  new l_deaths=param[1]
  new l_longkstreak=param[2]
  new l_longdstreak=param[3]
  new temp[255]
  format(temp, 255, "Your current streak is %d deaths. ^nYour longest killstreak is %d. Your longest deathstreak is %d.", l_deaths, l_longkstreak, l_longdstreak)
  show_hudmessage(VID, temp) 
  return PLUGIN_CONTINUE
}

public showstr_end_by(param[]){
  set_hudmessage(0, 150, 255, -1.0, 0.65, 2, 0.02, 10.0, 0.01, 6.0, 3) 
  new l_victim = param[0]
  new l_killer = param[1]
  new l_kills=param[2]
  new l_hs=param[3]
  new l_nade=param[4]
  new l_knife=param[5]
  new l_vname[32]
  get_user_name(l_victim,l_vname,31)
  new l_kname[32]
  get_user_name(l_killer,l_kname,31)	
  new sBuffer[255]
  new iLen=0
  sBuffer[0] = 0
  iLen = format(sBuffer, 255, "%s's^nkilling spree ^n%d kills",l_vname,l_kills)  
  if(l_hs || l_nade || l_knife) {	
    iLen += format( sBuffer[iLen], 255 - iLen," (")
    if(l_hs) iLen += format( sBuffer[iLen], 255 - iLen,"%d hs ",l_hs)  
    if(l_nade)	iLen += format( sBuffer[iLen], 255 - iLen, "%d nade ",l_nade)
    if(l_knife)	iLen += format( sBuffer[iLen], 255 - iLen, "%d knife ",l_knife)
    iLen += format( sBuffer[iLen], 255 - iLen,")")
  }

  iLen += format( sBuffer[iLen], 255 - iLen,"^nwas ended by^n%s",l_kname)
  show_hudmessage(0,sBuffer) 
  return PLUGIN_CONTINUE
}
// end of Killstreak part
