/* AMX Mod script. (Nov 9th, 2003)
 *
 * Ping Analyzer
 * by DanRaZor
 *
 * Made with AMXPluginCreator by Virtual
 *
 */

#include <amxmod>
#include <amxmisc>

#define NB_CHECKS 10

new Float:lastPings[NB_CHECKS]
new Float:lastLoss[NB_CHECKS]
new Float:currentPing						= 0.0
new Float:currentLoss						= 0.0
new Float:timer 								= 1.0
new pingMax											= 100
new Float:maxPingForMap					= 0.0
new Float:maxLossForMap					= 0.0
new Float:avePingForMap					= 0.0
new Float:aveLossForMap					= 0.0
new tic													= 0
new nbChecks										= 0
new next												= 0
new alertV											= 0

public init_first() {
	for(new j = 0 ; j < NB_CHECKS ; ++j ) {
			lastPings[j] = -1.0
			lastLoss[j]	 = -1.0 	
	}
	maxLossForMap = 0.0
	aveLossForMap = 0.0
	avePingForMap = 0.0
	maxPingForMap = 0.0
	nbChecks = 0
	tic = 0	
	if ( next ) 
		set_task( 5.0 , "startWork" )		
}

public startWork () {
	set_task( timer , "updatePing" )
}

public alert_admins () {
	for(new i = 1 ; i < 33 ; ++i ) {
		if ( is_user_connected(i) ) { 
	  	if ( !is_user_bot(i) ){
				if ( get_user_flags(i) & ADMIN_LEVEL_B ) {
					new text[100]
					format(text,99,"OVERLOAD : Average ping %.0f", currentPing)
					set_hudmessage(100,0,0,-1.0,0.7,0, 0.01, 5.0, 0.01, 0.01, 12 )
					show_hudmessage( i , text )				
				}
			}
		}	
	}
}

public updatePing() {
  new Ping, Loss
  new Float:avePing = 0.0
  new Float:aveLoss = 0.0
  new nb = 0
  for(new i = 1 ; i < 33 ; ++i ) {
  	if ( is_user_connected(i) ) { 
	  	if ( !is_user_bot(i) ){
	  		get_user_ping( i , Ping, Loss)	  		
	  		avePing += float(Ping)
	  		aveLoss += float(Loss)
	  		++nb
	  	}
	  }
  }
  if ( nb > 0 ) {
  	avePing /= float(nb)
  	aveLoss /= float(nb)
  }
  lastPings[tic] = avePing
  lastLoss[tic]  = aveLoss
  ++tic
  if ( tic == 10 ) {
  	aveLossForMap += currentLoss
  	avePingForMap += currentPing
  	++nbChecks
  	tic = 0 
  }
  nb  = 0
  new Float:currentPingTemp = 0.0
  new Float:currentLossTemp = 0.0
  for(new j = 0 ; j < NB_CHECKS ; ++j ) {
  	if ( lastPings[j] != -1.0 ) {
  		currentPingTemp += lastPings[j]
  		++nb
  	}
  	if ( lastLoss[j] != -1.0 ) {
  		currentLossTemp += lastLoss[j]
  	}
  }
  if ( nb > 0 ) {
  	currentPingTemp /= float(nb)
  	currentLossTemp /= float(nb)
  }
  currentPing = currentPingTemp
  currentLoss = currentLossTemp
  if ( currentPing > pingMax )
  	if ( alertV == 1 )
  		alert_admins ()
  if ( currentPing > maxPingForMap )
  	maxPingForMap = currentPing
  if ( currentLoss > maxLossForMap )
  	maxLossForMap = currentLoss
  if ( next )
  	set_task( timer , "updatePing" )
}

public showPing ( id ) {
	new message[50]
	if ( next ) 
		format(message, 49, "Ping Average : %.0f", currentPing )
	else
		format(message, 49, "Ping Average : NOT AVAILABLE" )
	set_hudmessage(150,200,0,0.7,0.8,0, 0.01, 5.0, 0.01, 0.01, 11 )
	show_hudmessage( id , message )
	return PLUGIN_CONTINUE
}

public showLoss ( id ) {
	new message[50]
	if ( next ) 
		format(message, 49, "Loss Average : %.0f", currentLoss )
	else
		format(message, 49, "Loss Average : NOT AVAILABLE" )
	set_hudmessage(150,200,0,0.7,0.8,0, 0.01, 5.0, 0.01, 0.01, 11 )
	show_hudmessage( id , message )
	return PLUGIN_CONTINUE
}

public startAnalyze ( id,level,cid ) {
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED
	if (!next)
		set_task( timer , "updatePing" )
	next = 1
	return PLUGIN_HANDLED
}

public stopAnalyze ( id,level,cid ) {
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED
	next = 0
	return PLUGIN_HANDLED
}

public setMaxping ( id,level,cid ) {
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new param[10]
	read_argv(1,param,9)
	new newValue = str_to_num(param);
	pingMax = newValue
	new text[60]
	format(text, 59, "[AMX] Max Ping average set to %d", pingMax )
	console_print(id,text)
	return PLUGIN_HANDLED
}

public endMapStats () {
	new text[200],map[100],date2[100]
	aveLossForMap /= float(nbChecks)
	avePingForMap /= float(nbChecks)
	get_mapname(map,99)
	get_time("%m/%d/%Y - %H:%M:%S",date2,99);
	format(text,199,"MAP %16s [ PING : MAX %4.0f - AVERAGE %4.0f ] [ LOSS : MAX %4.0f - AVERAGE %4.0f ] [ Date : %20s ]",map,maxPingForMap,avePingForMap,maxLossForMap,aveLossForMap,date2)
	write_file("ping.log",text)	
}

public activateAlert () {
	alertV = 1
}

public disableAlert () {
	alertV = 0
}

public plugin_end() {
	endMapStats ()
}

public plugin_init() {
	register_plugin("Ping Analyzer","1.0","DanRaZor")

	register_clcmd ("say /ping"							,"showPing"			,0					,"- displays ping average")
	register_clcmd ("say /loss"							,"showLoss"			,0					,"- displays loss average")
	
	register_concmd("amx_startPingAnalyze"	,"startAnalyze"	,ADMIN_RCON	,"- starts PING Analyzis")
	register_concmd("amx_stopPingAnalyze"		,"stopAnalyze"	,ADMIN_RCON	,"- stops PING Analyzis")
	
	register_concmd("amx_activatePingAlert"	,"activateAlert",ADMIN_RCON	,"- enables PING alert to admins")
	register_concmd("amx_disablePingAlert"	,"disableAlert"	,ADMIN_RCON	,"- disables PING alert to admins")
	
	register_concmd("amx_setMaxPing"				,"setMaxping"		,ADMIN_RCON	,"- sets the max ping average value to alert admins")
	
	init_first()	
}
