
   /* AMX Mod script.
   *
   * (c) 2003, Phreak & SniperBeamer
   * This file is provided as is (no warranties).
   *
   * On two minutes before the timelimit plugin
   * displays menu with 5 random maps to select.
   * You can also open the menu by saying "votemap".
   * One of the options is also map extending.
   * Map with most votes becomes the nextmap.
   *
   * Maps to selected are in maps.ini file.
   *
   * Cvars:
   * amx_vote_answers <0/1> - the votes of players will be announced
   * amx_extendmap_max <time in mins.> - max. time for overall extending
   *  amx_extendmap_step <time in mins.> - with what time the map will be
   extended
   *
   * NOTE: Nextmap plugin is required for proper working of this plugin.
   */
   #include <amxmod>
   #define MAX_MAPS    128
   #define SELECTMAPS    5
   new g_mapName[MAX_MAPS][32]
   new g_mapNums
   new g_nextName[SELECTMAPS]
   new g_voteCount[SELECTMAPS+2]
   new g_votePlayer[33]
   new g_mapVoteNum
   new g_teamScore[2]
   new g_lastMap[32]
   new bool:cstrike_running
   new bool:checkedVotes = false
   new logfilename[16]
   public plugin_init()
   {
       register_plugin("eXtended   Nextmap   chooser","0.9.4","Phreak   &
   SniperBeamer")
       register_cvar("amx_vote_answers","1")
       register_cvar("amx_extendmap_max","90")
       register_cvar("amx_extendmap_step","15")
       get_localinfo("lastMap",g_lastMap,31)
       set_localinfo("lastMap","")
       new basedir[32],workfile[64]
       get_localinfo("amx_basedir",basedir,31)
       format(workfile,63,"%s/maps.ini",basedir)
       if (load_settings(workfile))
       {
           register_menucmd(register_menuid("AMX                   Choose
   nextmap:"),(-1^(-1<<(SELECTMAPS+2))),"countVote")
           register_clcmd("say votemap","displayMenu")
           register_clcmd("say_team votemap","displayMenu")
           new mod_name[32]
           get_modname(mod_name,31)
           cstrike_running = equal(mod_name,"cstrike") ? true : false
           if (cstrike_running)
   register_event("TeamScore","team_score","a")
           get_time("admin%m%d.log",logfilename,15)
           create_menu()
           set_task(15.0,"checkTask",987456,"",0,"b")
       }
   }
   load_settings(filename[])
   {
       if (!file_exists(filename)) return 0
       new szText[32]
       new a, pos = 0
       new currentMap[32]
       get_mapname(currentMap,31)
       while ( g_mapNums < MAX_MAPS &&
   read_file(filename,pos++,szText,31,a) )
       {
           if ( szText[0] != ';'
            && parse(szText,g_mapName[g_mapNums],31)
            && is_map_valid(g_mapName[g_mapNums])
            && !equali(g_mapName[g_mapNums],g_lastMap)
            && !equali(g_mapName[g_mapNums],currentMap) )
               ++g_mapNums
       }
       return g_mapNums
   }
   bool:isInMenu(id)
   {
      for(new a=0; a<g_mapVoteNum; ++a)
         if (id==g_nextName[a])
            return true
      return false
   }
   create_menu()
   {
       new dmax = (g_mapNums > SELECTMAPS) ? SELECTMAPS : g_mapNums
       for(g_mapVoteNum = 0;g_mapVoteNum<dmax;++g_mapVoteNum)
       {
           new a=random_num(0,g_mapNums-1)
           while( isInMenu(a) )
               if (++a >= g_mapNums) a = 0
           g_nextName[g_mapVoteNum] = a
       }
   }
   public displayMenu(id)
   {
       if (checkedVotes) return PLUGIN_HANDLED
       new mp_winlimit = get_cvar_num("mp_winlimit")
       new mp_maxrounds = get_cvar_num("mp_maxrounds")
       new menu[512], a, mkeys = (1<<SELECTMAPS+1)
       new   pos   =   copy(menu,511,cstrike_running   ?   "\yAMX  Choose
   nextmap:\w^n^n" : "AMX Choose nextmap:^n^n")
       new dmax = (g_mapNums > SELECTMAPS) ? SELECTMAPS : g_mapNums
       for(a = 0;a<dmax;a++)
       {
           if (g_votePlayer[id]==a) pos += format(menu[pos],511-pos,"\r")
           pos += format(menu[pos],511-pos,"%d.
   %s\w^n",a+1,g_mapName[g_nextName[a]])
           mkeys |= (1<<a)
       }
       menu[pos++]='^n'
       new mapname[32]
       get_mapname(mapname,31)
       if (!mp_winlimit && !mp_maxrounds &&
   get_cvar_float("mp_timelimit") < get_cvar_float("amx_extendmap_max"))
       {
           if         (g_votePlayer[id]==SELECTMAPS)        pos        +=
   format(menu[pos],511-pos,"\r")
           pos     +=     format(menu[pos],511-pos,"%d.     Extend    map
   %s\w^n",SELECTMAPS+1,mapname)
           mkeys |= (1<<SELECTMAPS)
       }
       format(menu[pos],511,"%d. None",SELECTMAPS+2)
       show_menu(id,mkeys,menu,15)
       return PLUGIN_HANDLED
   }
   public countVote(id,key)
   {
       if ( get_cvar_num("amx_vote_answers") )
       {
           new name[32]
           get_user_name(id,name,31)
           if ( key == SELECTMAPS )
               client_print(0,print_chat,"%s chose map extending", name )
           else if ( key < SELECTMAPS )
               client_print(0,print_chat,"%s     chose     %s",     name,
   g_mapName[g_nextName[key]] )
       }
       if (g_votePlayer[id] != -1)
           --g_voteCount[ g_votePlayer[id] ]
       if (key == SELECTMAPS+1)
       {
           g_votePlayer[id] = -1
           return PLUGIN_HANDLED
       }
       ++g_voteCount[key]
       g_votePlayer[id] = key
       return PLUGIN_HANDLED
   }
   public checkVotes()
   {
       checkedVotes = true
       new b = 0
       for(new a = 0; a < g_mapVoteNum; ++a)
           if (g_voteCount[b] < g_voteCount[a])
               b = a
       if ( g_voteCount[SELECTMAPS] > g_voteCount[b] )
       {
           new mapname[32]
           get_mapname(mapname,31)
           new Float:steptime = get_cvar_float("amx_extendmap_step")
           set_cvar_float("mp_timelimit",  get_cvar_float("mp_timelimit")
   + steptime )
           client_print(0,print_chat,"Choosing finished. Current map will
   be extended to next %.0f minutes", steptime )
           log_to_file(logfilename,"Vote:    Voting   for   the   nextmap
   finished. Map %s will be extended to next %.0f minutes",
               mapname , steptime )
           return
       }
       if ( g_voteCount[b] && g_voteCount[SELECTMAPS+1] <= g_voteCount[b]
   )
           set_cvar_string("amx_nextmap", g_mapName[g_nextName[b]] )
       new smap[32]
       get_cvar_string("amx_nextmap",smap,31)
       client_print(0,print_chat,"Choosing  finished. The nextmap will be
   %s", smap )
       log_to_file(logfilename,"Vote:  Voting  for  the nextmap finished.
   The nextmap will be %s", smap)
   }
   public checkTask()
   {
       new winlimit = get_cvar_num("mp_winlimit")
       new maxrounds = get_cvar_num("mp_maxrounds")
       if ( winlimit )
       {
           new c = winlimit - 2
           if ( (c > g_teamScore[0]) && (c > g_teamScore[1]) )
               return
       }
       else  if ( maxrounds )
       {
           if ( (maxrounds - 2) > (g_teamScore[0] + g_teamScore[1]) )
               return
       }
       else
       {
           new timeleft = get_timeleft()
           if (timeleft<1||timeleft>129)
               return
       }
       remove_task(987456)
       new players[32],num
       get_players(players,num,"c")
       for (new i=0; i<num; i++)
           if (g_votePlayer[ players[i] ] == -1)
           {
               displayMenu(players[i])
               client_print(players[i],print_chat,"It's  time  to  choose
   the nextmap...")
               client_cmd(players[i],"spk Gman/Gman_Choose2")
           }
       set_task(15.0,"checkVotes")
   }
   public team_score()
   {
       new team[2]
       read_data(1,team,1)
       g_teamScore[ (team[0]=='C') ? 0 : 1 ] = read_data(2)
       return PLUGIN_CONTINUE
   }
   public client_connect(id)
   {
       g_votePlayer[id] = -1
   }
   public client_disconnect(id)
   {
       if (g_votePlayer[id] != -1)
           --g_voteCount[ g_votePlayer[id] ]
   }
   public plugin_end()
   {
       new current_map[32]
       get_mapname(current_map,31)
       set_localinfo("lastMap",current_map)
   }
