/* AMX Mod script. (Nov 10th, 2002)
*
* Task Scheduler 0.2
*  by JustinHoMi
*
* amx_task time "task" flags
* flags:
*  m - time is in minutes
*  s - time is in seconds
*  r - repeat task
*  t - specific time
*  b - time before end of map
*
*/

#include <amxmod>

new task_cmds[32][108]
new task_times[32][16]
new task_flag[32]
new task_done[32]
new numtasks = 0

public load_task(){
	if (read_argc() < 4) {
		server_print("[AMX] Usage:  amx_task < time > ^"command^" < flags >")
		return PLUGIN_HANDLED
	}

	new args[128]
	read_args(args,128)
	new time2[6], cmd[108], flags[5]

	parse(args,time2,6,cmd,108,flags,5)
	new Float:time_f = floatstr(time2)

	new flag[2] = ""
	new multiplier = 1
	if (contain(flags,"r") != -1)
		flag="b"
	if (contain(flags,"m") != -1) {
		multiplier = 60;
		time_f = time_f * 60
	}

	if (contain(flags,"t") != -1) {			// specific time (t)
		copy(task_cmds[numtasks],108,cmd)
		copy(task_times[numtasks],6,time2)
		task_flag[numtasks] = 1
		numtasks++
	} else if (contain(flags,"b") != -1) {	// before end of map (b)
		copy(task_cmds[numtasks],108,cmd)
		task_times[numtasks][0] = strtonum(time2) * multiplier // to save a lil cpu
		//copy(task_times[numtasks],6,time)
		task_flag[numtasks] = 2
		numtasks++
	} else {
		set_task(time_f,"run_task",0,cmd,108,flag)
	}

	return PLUGIN_HANDLED
}

public run_task(cmd[]) {
	server_cmd(cmd)
	return PLUGIN_HANDLED
}

public check_time() {
	if (numtasks){
		for (new i=0; i<numtasks; i++) {
			if (!task_done[i]) {
				if (task_flag[i] == 1){ 			// specific time (t)
					new curtime[16]
					get_time("%H:%M",curtime,16)
					if(equal(curtime,task_times[i]))
						server_cmd(task_cmds[i])
				} else if (task_flag[i] == 2) {		// time before end of map (b)
					if (task_times[i][0] >= get_timeleft()){
						server_cmd(task_cmds[i])
						task_done[i] = 1
					}
				}
			}
		}
	}

	return PLUGIN_CONTINUE
}

public plugin_init() {
	register_plugin("Task Scheduler","0.3","JustinHoMi")
	register_srvcmd("amx_task","load_task")
	set_task(5.0,"check_time",1,"",0,"b")
	return PLUGIN_CONTINUE
}

